<?php


/**
 * @desc display and process IP restriction Form
 *
 * @param string $environment : 'application' if launched from UI, 'browser' if launched from web browser
 * @param mixed $userFile : - false for general IP restrictions
 * 						    - user configuration file name for user IP restrictions
 * 							- or user ID for for user IP restrictions
 */
function acIPForm($environment, $userFile=false){
	function checkLocalIsSet(){
		if(strpos(cfGGetVar('IPFilterIncluded'),'127.0.0.1')===false){
			if(!cfGGetVar('IPFilterIncluded')) cfGUpdateVar('IPFilterIncluded','127.0.0.1'); else cfGUpdateVar('IPFilterIncluded','127.0.0.1;'.cfGGetVar('IPFilterIncluded'));
		}
	}
	$_ENV['configurationEnvironment']=$environment;

/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
	if(isset($_POST['act']) && isset($_POST['userFile']) && ($_POST['userFile']=='general' || file_exists(cfAppDataDir().'/groups/'.cfUTF8Decode($_POST['userFile'])))){
		$userFileName=cfAppDataDir().'/groups/'.cfUTF8Decode($_POST['userFile']);

		// Read user data if needed
		if($_POST['userFile']!='general') {
			require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
			$userData=cfParse_ini_file($userFileName);
			if(!isset($userData['IPFilterIncluded'])) $userData['IPFilterIncluded']='';
			if(!isset($userData['IPFilterExcluded'])) $userData['IPFilterExcluded']='';
		}

		// Change filter
		if($_POST['act']=='changeFilter' && ($_POST['mode']=='no' || $_POST['mode']=='include' || $_POST['mode']=='exclude' || $_POST['mode']=='LAN')){
			// Application-level
			if($_POST['userFile']=='general'){
				if($_POST['mode']=='LAN'){
					cfGUpdateVar('IPFilterIncluded','127.0.0.1;10.*.*.*;192.168.*.*');
					cfGUpdateVar('IPFilter','include');
				}
				else {
					cfGUpdateVar('IPFilter',$_POST['mode']);
				}

				// Commit to .htaccess
				cfHtaccessMainWrite();
			}
			// User level
			else{
				if($_POST['mode']=='LAN'){
					$userData['IPFilter']='include';
					$userData['IPFilterIncluded']='127.0.0.1;10.*.*.*;192.168.*.*';
				}
				else $userData['IPFilter']=$_POST['mode'];
				rcWriteUserFile($userData,cfUTF8Decode($_POST['userFile']));
			}
		}
		// Add an included IP
		elseif($_POST['act']=='addInclude' && isset($_POST['newInclude']) && cfIsIP($_POST['newInclude'])){
			// General setting
			if($_POST['userFile']=='general'){

				if(strpos(cfGGetVar('IPFilterIncluded'),$_POST['newInclude'])===false){
					if(!cfGGetVar('IPFilterIncluded') || strlen(cfGGetVar('IPFilterIncluded'))==0)
						cfGUpdateVar('IPFilterIncluded',$_POST['newInclude']);
					else
						cfGUpdateVar('IPFilterIncluded',cfGGetVar('IPFilterIncluded').';'.$_POST['newInclude']);
					checkLocalIsSet();

					cfGUpdateVar('IPFilter','include');

					// Commit to .htaccess
					cfHtaccessMainWrite();
				}
			}
			else{
				// Per user setting
				$userData['IPFilter']='include';
				if(strpos($userData['IPFilterIncluded'],$_POST['newInclude'])===false){
					if(!isset($userData['IPFilterIncluded']) || strlen($userData['IPFilterIncluded'])==0)
						$userData['IPFilterIncluded']=$_POST['newInclude'];
					else
						$userData['IPFilterIncluded'].=';'.$_POST['newInclude'];
					// Save modifications
					rcWriteUserFile($userData,cfUTF8Decode($_POST['userFile']));
				}
			}
		}
		// Add an excluded IP
		elseif($_POST['act']=='addExclude' && isset($_POST['newExclude']) && cfIsIP($_POST['newExclude'])){

			// Remove masks matching with 127.0.01
			$bytes=explode('.',str_replace('255','*',$_POST['newExclude']));
			$nbNok=0;
			if($bytes[0]=='127'||$bytes[0]=='*') $nbNok++;
			if($bytes[1]=='0'||$bytes[1]=='*') $nbNok++;
			if($bytes[2]=='0'||$bytes[2]=='*') $nbNok++;
			if($bytes[3]=='1'||$bytes[3]=='*') $nbNok++;

			// General setting
			if($_POST['userFile']=='general' && $nbNok<4){
				if(strpos(cfGGetVar('IPFilterExcluded'),$_POST['newExclude'])===false){
					if(!cfGGetVar('IPFilterExcluded') || strlen(cfGGetVar('IPFilterExcluded'))==0)
						cfGUpdateVar('IPFilterExcluded',$_POST['newExclude']);
					else
						cfGUpdateVar('IPFilterExcluded',cfGGetVar('IPFilterExcluded').';'.$_POST['newExclude']);
					cfGUpdateVar('IPFilter','exclude');

					// Commit to .htaccess
					cfHtaccessMainWrite();
				}
			}
			elseif($nbNok<4){
				// Per user setting
				$userData['IPFilter']='exclude';
				if(strpos($userData['IPFilterExcluded'],$_POST['newExclude'])===false){
					if(!isset($userData['IPFilterExcluded']) || strlen($userData['IPFilterExcluded'])==0)
						$userData['IPFilterExcluded']=$_POST['newExclude'];
					else
						$userData['IPFilterExcluded'].=';'.$_POST['newExclude'];
					// Save modifications
					rcWriteUserFile($userData,cfUTF8Decode($_POST['userFile']));
				}
			}
		}
		// Remove an included IP
		elseif($_POST['act']=='removeIncludedIP' && isset($_POST['removedIP'])){
			if($_POST['userFile']=='general'){
				$IPFilterIncluded=explode(';',cfGGetVar('IPFilterIncluded'));
				if(isset($IPFilterIncluded[$_POST['removedIP']])){
					unset($IPFilterIncluded[$_POST['removedIP']]);
					cfGUpdateVar('IPFilterIncluded',implode(';',$IPFilterIncluded));
					checkLocalIsSet();

					if(count($IPFilterIncluded)) cfGUpdateVar('IPFilter','include'); else cfGUpdateVar('IPFilter','no');

					// Commit to .htaccess
					cfHtaccessMainWrite();
				}
			}
			else{
				$IPFilterIncluded=explode(';',$userData['IPFilterIncluded']);
				if(isset($IPFilterIncluded[$_POST['removedIP']])){
					unset($IPFilterIncluded[$_POST['removedIP']]);
					$userData['IPFilterIncluded'] = implode(';',$IPFilterIncluded);
					if(count($IPFilterIncluded)) $userData['IPFilter']='include'; else $userData['IPFilter']='no';
					// Save modifications
					rcWriteUserFile($userData,cfUTF8Decode($_POST['userFile']));
				}
			}
		}
		// Remove an excluded IP
		elseif($_POST['act']=='removeExcludedIP' && isset($_POST['removedIP'])){
			if($_POST['userFile']=='general'){
				$IPFilterExcluded=explode(';',cfGGetVar('IPFilterExcluded'));
				if(isset($IPFilterExcluded[$_POST['removedIP']])){
					unset($IPFilterExcluded[$_POST['removedIP']]);
					cfGUpdateVar('IPFilterExcluded',implode(';',$IPFilterExcluded));

					if(count($IPFilterExcluded)) cfGUpdateVar('IPFilter','exclude'); else cfGUpdateVar('IPFilter','no');

					// Commit to .htaccess
					cfHtaccessMainWrite();
				}
			}
			else{
				$IPFilterExcluded=explode(';',$userData['IPFilterExcluded']);
				if(isset($IPFilterExcluded[$_POST['removedIP']])){
					unset($IPFilterExcluded[$_POST['removedIP']]);
					$userData['IPFilterExcluded'] = implode(';',$IPFilterExcluded);
					if(count($IPFilterExcluded)) $userData['IPFilter']='exclude'; else $userData['IPFilter']='no';
					// Save modifications
					rcWriteUserFile($userData,cfUTF8Decode($_POST['userFile']));
				}
			}
		}
	}


	// Load parameters
	if($userFile===false || $userFile=='general'){
		$userFile='general';
		if(cfGGetVar('IPFilter')) $IPFilter=cfGGetVar('IPFilter'); else $IPFilter='no';
		$IPFilterIncluded=explode(';',cfGGetVar('IPFilterIncluded'));
		$IPFilterExcluded=explode(';',cfGGetVar('IPFilterExcluded'));
	}
	elseif(file_exists(cfAppDataDir().'/groups/'.$userFile) && cfFileExtension($userFile)=='usr'){
		$userData=cfParse_ini_file(cfAppDataDir().'/groups/'.$userFile);
		if(isset($userData['IPFilter'])) $IPFilter=$userData['IPFilter']; else $IPFilter='no';
		if(!isset($userData['IPFilterIncluded'])) $userData['IPFilterIncluded']='';
		if(!isset($userData['IPFilterExcluded'])) $userData['IPFilterExcluded']='';
		$IPFilterIncluded=explode(';',$userData['IPFilterIncluded']);
		$IPFilterExcluded=explode(';',$userData['IPFilterExcluded']);
	}
	else outDisplayErrorPage(cfCaption('configInvalidFile'));

/*
 ***************************************************************************************************************************
 * Insert HEAD, JS functions and form
 ***************************************************************************************************************************
 */

	if(cfIsAsync()) {
		cfAsyncHeader();
		cfAsyncFooter();
	}

	cfInsertHEAD(false,array('icon'=>'warning','size'=>'480x400','title'=>cfCaption('configIPFilter')));
?>
</head>
<body width="480" height="360" onContextMenu="return false;" style="cursor:default;overflow:hidden" onSelect="D.deselForm.desel.select()" onload="init()">
<form style="position:absolute;top:-100px" name="deselForm"><input type="text" name="desel" value="a">a</input></form>
<script type="text/javascript" language="javascript">
var filter="<?php echo $IPFilter;?>";
function onrightclick(e){return false}
function init(){wl.UICommand('fadeSize','480x'+(20+actualOffsetBottom(dgi('topDiv'))))}
function cfIsIP(text){
	text=text.replace(/\*/g,"255");
	var IPExp=/\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/g;
	if(text.match(IPExp)!=null && text.match(IPExp).length==1) return true; else return false;
}
function changeFilter(newFilter){
	filter=newFilter;
	if(filter=='include') dgi('includeInnerDiv').style.display='inline'; else dgi('includeInnerDiv').style.display='none';
	if(filter=='exclude') dgi('excludeInnerDiv').style.display='inline'; else dgi('excludeInnerDiv').style.display='none';
	save();
	wl.UICommand('fadeSize','480x'+(20+actualOffsetBottom(dgi('topDiv'))));

}
function addInclude(e){
	var kc;
	if(e) {if(e.which!=13) return;}
	else {
		if (window.event && window.event.keyCode){
			if(window.event.keyCode!=13) return;
		}
	}

	var IP=dgi('newInclude').value;
	if(!cfIsIP(IP)) alert("<?php echo cfCaptionJS('IPFilterIncorrectIP')?>");
	else{
		D.IPForm.act.value="addInclude";
		D.IPForm.submit();
	}
}
function addExclude(e){
	var kc;
	if(e) {if(e.which!=13) return;}
	else if (W.event && W.event.keyCode && W.event.keyCode!=13) return;

	var IP=dgi('newExclude').value;
	if(!cfIsIP(IP)) alert("<?php echo cfCaptionJS('IPFilterIncorrectIP')?>");
	else{
		D.IPForm.act.value="addExclude";
		D.IPForm.submit();
	}
}

function removeIncludedIP(IPid){
	D.IPForm.removedIP.value=IPid;
	D.IPForm.act.value="removeIncludedIP";
	D.IPForm.submit();
}
function removeExcludedIP(IPid){
	D.IPForm.removedIP.value=IPid;
	D.IPForm.act.value="removeExcludedIP";
	D.IPForm.submit();
}
function save(){
	D.IPForm.act.value="changeFilter";
	asyncSubmitForm('IPForm');
}
function cancel(){}
</script>
<div id="topDiv">

<?php
// Check if rules match with LAN restriction
if($IPFilter=='include' && (($userFile && $userFile!='general' && $userData['IPFilterIncluded']=='127.0.0.1;10.*.*.*;192.168.*.*') || ((!$userFile || $userFile=='general') && cfGGetVar('IPFilterIncluded')=='127.0.0.1;10.*.*.*;192.168.*.*'))) $isLAN=true; else $isLAN=false;
/*
 ***************************************************************************************************************************
 * Display IP filter form
 ***************************************************************************************************************************
 */

echo outDivFrame('frame1');
echo '<div class="frame1Header">'.cfCaption('IPFilterTitle').'</div><br>';
echo '<form name="IPForm" id="IPForm" action="'.$_SERVER['PHP_SELF'].'" method="POST" enctype="multipart/form-data" onsubmit="return false;">';

// resource ID
if(isset($_SESSION['activeResourceId'])) echo '<input type="text" name="resId" value="'.$_SESSION['activeResourceId'].'" style="display:none">';

// Range
echo '<input type="text" name="userFile" value="'.$userFile.'" style="display:none">';

// removedIP
echo '<input type="text" name="removedIP" value="" style="display:none">';

// Action
echo '<input type="text" name="act" value="" style="display:none">';

echo '<b>';
if($userFile=='general') echo cfCaption('IPFilterGlobal'); else echo cfCaption('IPFilterAccount', cfUTF8Encode($userData['name']));
echo '</b><br/><br/>'.cfCaption('IPFilterNotice')."<br/><br/>\n";

// No filtering
echo outDivFrame('frame2');
echo outFrameHeaderTable('frame2Header','<input id="noFilterInput" onclick="javascript:changeFilter(\'no\')" type="radio" name="mode" value="no"'.(($IPFilter=='no')?' checked> ':'> ').'<span style="cursor:pointer" onclick="n=this.previousSibling.previousSibling;n.checked=true;n.onclick()">'.cfCaption('IPFilterNo')).'</span>';
echo '</div>';

// Included IP
echo outDivFrame('frame2');
echo outFrameHeaderTable('frame2Header','<input onclick="javascript:changeFilter(\'include\')" type="radio" name="mode" value="include"'.(($IPFilter=='include' && !$isLAN)?' checked> ':'> ').'<span style="cursor:pointer" onclick="n=this.previousSibling.previousSibling;n.checked=true;n.onclick()">'.cfCaption('IPFilterInclude')).'</span>';
echo '<div id="includeInnerDiv" style="display:'.(($IPFilter=='include' && !$isLAN)?'inline':'none')."\">\n";
foreach ($IPFilterIncluded as $key => $value) if($value!=''){
	echo '<span style="margin:1em"></span>';
	if($value=='127.0.0.1') echo outButtonSmallDisabled('',outIcon('cancel'), cfCaption('genDelete'));
	else echo outButtonSmall('','javascript:removeIncludedIP(\''.$key.'\')',outIcon('cancel'), cfCaption('genDelete'));
	echo '<span style="margin-left:2em;vertical-align:top">'.$value.'</span>'."<br/>";
}
echo cfCaption('IPFilterAdd');
echo '<input style="margin: 0 2em 0 2em" class="textInput" type="text" id="newInclude" name="newInclude" size="12" maxlength="15">';
echo outBt('',outIcon('add'),'javascript:addInclude()',false,false,'style="vertical-align:bottom"');
echo '</div></div>';

// Excluded IP
echo outDivFrame('frame2');
echo outFrameHeaderTable('frame2Header','<input onclick="javascript:changeFilter(\'exclude\')" type="radio" name="mode" value="exclude"'.(($IPFilter=='exclude')?' checked> ':'> ').'<span style="cursor:pointer" onclick="n=this.previousSibling.previousSibling;n.checked=true;n.onclick()">'.cfCaption('IPFilterExclude')).'</span>';
echo '<div id="excludeInnerDiv" style="display:'.(($IPFilter=='exclude')?'inline':'none')."\">\n";
foreach ($IPFilterExcluded as $key => $value) if($value!=''){
	echo '<span style="margin:1em"></span>'.outButtonSmall('','javascript:removeExcludedIP(\''.$key.'\')',outIcon('cancel'), cfCaption('genDelete')).'<span style="margin:2em;vertical-align:top">'.$value.'</span>'."<br/>";
}
echo cfCaption('IPFilterAdd');
echo '<input style="margin: 0 2em 0 2em" class="textInput" type="text" id="newExclude" name="newExclude" size="12" maxlength="15">';
echo outBt('',outIcon('add'),'javascript:addExclude()',false,false,'style="vertical-align:bottom"');
echo '</div></div>';

// Local network only
echo outDivFrame('frame2');
echo outFrameHeaderTable('frame2Header','<input onclick="javascript:changeFilter(\'LAN\')" type="radio" name="mode" value="LAN"'.(($isLAN)?' checked> ':'> ').'<span style="cursor:pointer" onclick="n=this.previousSibling.previousSibling;n.checked=true;n.onclick()">'.cfCaption('IPFilterLANOnly')).'</span>';
echo '</div>';


// Save / Cancel buttons
	echo '<br/><center>';
	if(!cfIsInApp()) echo  '<span style="padding-left:5em;"></span>'.outBt(cfCaption('genCancel'),outIcon('cancel'),'javascript:winMe.closeMe()');
	// Close button: return 1 if any filter set, 0 if none (used by uiUsers.php to update IP filter button's icon)
	else echo  outBt(cfCaption('genClose'),outIcon('closeOK'),"javascript:wl.UICommand('close:'+((dgi('noFilterInput').checked)?0:1))");
	echo  '</center>';

echo '</form>';
echo '</div>'; // frame1
echo '</div>'; // topDiv
?>
<script type="text/javascript">
dgi("newExclude").onkeydown=addExclude;
dgi("newInclude").onkeydown=addInclude;
</script>
<?php
echo '</body></html>';
}

/**
 * @desc remove background images for selected theme
 *
 * @param string $theme
 */
function wallpaperFormClearImage($theme){
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-centered.jpg');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-stretched.jpg');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-tiled.jpg');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-centered.gif');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-stretched.gif');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-tiled.gif');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-centered.png');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-stretched.png');
	@unlink(cfAppDocRoot().'/themes/'.$theme.'/wallpaper-tiled.png');
}

/**
 * @desc Theme wallpaper selection form
 * 		Can be called by /local/wallpaper.php script (from application config panel button)
 */
function wallpaperForm($wpTheme=false){
	// Get theme
	if(!$wpTheme){
		$wpTheme=cfGGetVar('theme');
		if(isset($_GET['theme'])) $wpTheme=$_GET['theme'];
		if(isset($_POST['theme'])) $wpTheme=$_POST['theme'];
		if(!is_dir(cfAppDocRoot().'/themes/'.$wpTheme) ||
		strtolower(cfAppDocRoot().'/themes/'.$wpTheme)!=strtolower(str_replace('\\','/',realpath(cfAppDocRoot().'/themes/'.$wpTheme)))){
			die('Theme not set');
		}
	}
	// Analyze current wallpaper
	$wallpaper=false;
	$wallpaperPosition='centered';
	if(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-centered.jpg')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-centered.jpg'; $wallpaperPosition='centered';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-stretched.jpg')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-stretched.jpg'; $wallpaperPosition='stretched';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-tiled.jpg')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-tiled.jpg'; $wallpaperPosition='tiled';}
	if(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-centered.gif')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-centered.gif'; $wallpaperPosition='centered';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-stretched.gif')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-stretched.gif'; $wallpaperPosition='stretched';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-tiled.gif')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-tiled.gif'; $wallpaperPosition='tiled';}
	if(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-centered.png')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-centered.png'; $wallpaperPosition='centered';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-stretched.png')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-stretched.png'; $wallpaperPosition='stretched';}
	elseif(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-tiled.png')){$wallpaper='/themes/'.$wpTheme.'/wallpaper-tiled.png'; $wallpaperPosition='tiled';}
	if(!$wallpaperPosition) $wallpaperPosition='centered';


	/*
	 ***************************************************************************************************************************
	 * Process completed upload
	 ***************************************************************************************************************************
	 */
	if(isset($_POST['useWallpaper']) && isset($_POST['position']) && isset($_FILES['image'])) {
		if($_POST['useWallpaper']=='no'){
			wallpaperFormClearImage($wpTheme);
			if(cfIsInApp())
				echo '<script language="javascript" type="text/javascript">parent.openWPForm("'.$wpTheme.'")</script>';
			else
				echo '<script language="javascript" type="text/javascript">parent.location.reload();</script>';
			exit;
		}
		else{

			// new image sent
			if(strlen($_FILES['image']['name']) && !empty($_FILES['image']['tmp_name']) && is_uploaded_file($_FILES['image']['tmp_name'])){

				if($_FILES['image']['type']!='image/jpeg' && $_FILES['image']['type']!='image/pjpeg' && $_FILES['image']['type']!='image/gif' && $_FILES['image']['type']!='image/png'){
					$incorrectFileType=true;
				}
				elseif($_POST['position']=='centered' || $_POST['position']=='stretched' || $_POST['position']=='tiled'){
					if(move_uploaded_file($_FILES['image']['tmp_name'], cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-temp.'.cfFileExtension($_FILES['image']['name']))){
						// Remove previous wallpaper
						wallpaperFormClearImage($wpTheme);

						// Copy uploaded wallpaper
						rename(cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-temp.'.cfFileExtension($_FILES['image']['name']), cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-'.$_POST['position'].'.'.((cfFileExtension($_FILES['image']['name'])=='jpeg')?'jpg':cfFileExtension($_FILES['image']['name'])));

						if(cfIsInApp())
							echo '<script language="javascript" type="text/javascript">parent.openWPForm("'.$wpTheme.'")</script>';
						else
							echo '<script language="javascript" type="text/javascript">parent.location.reload()</script>';
						exit;
					}
				}
			}
			// no new image
			else{
				// Change current wallpaper position
				if($wallpaper && $_POST['position']=='centered' || $_POST['position']=='stretched' || $_POST['position']=='tiled'){
					@rename(cfAppDocRoot().$wallpaper,cfAppDocRoot().'/themes/'.$wpTheme.'/wallpaper-'.$_POST['position'].'.'.cfFileExtension($wallpaper));
					if(cfIsInApp())
						echo '<script language="javascript" type="text/javascript">parent.openWPForm("'.$wpTheme.'")</script>';
					else
						echo '<script language="javascript" type="text/javascript">parent.location.reload();</script>';
					exit;
				}
			}
		}
	}

	// <head>
	cfInsertHEAD(false,array('size'=>'350x290','title'=>cfCaption('genWallpaper')));
	if(!cfIsInApp()) echo cfScriptLink('winClient.js');
	echo "</head>\n";

	// <body>
	echo '<body '.((!cfIsInApp())?' onload="winMe.setSize(380,'.((cfGetBrowser()=='ie')?310:280).');"':' oncontextmenu="return false;"').'>';

	if(!$wallpaper) $wallpaper=outIcon('appIcon');

	// <script>
	?>
	<script language="Javascript" type="text/javascript">
	var currentWallpaper="<?php echo $wallpaper.'?rnd='.rand();?>";
	function checkFile(){
		if(dgi('image').value.substr(dgi('image').value.length-4).toLowerCase()!='.gif' && dgi('image').value.substr(dgi('image').value.length-4).toLowerCase()!='.jpg' && dgi('image').value.substr(dgi('image').value.length-5).toLowerCase()!='.jpeg' && dgi('image').value.substr(dgi('image').value.length-4).toLowerCase()!='.png'){
			alert("<?php echo cfCaptionJS('blogErrorNotImage');?>");
			dgi('image').value="";
		}
		dgi('doUse').checked=true;
	}
	function setPosition(val){
		if(val=='no'){
			dgi("doUse").checked=false;
			dgi('preview').innerHTML='';
			return;
		}
		if(!val){
			if(dgi('pc').checked) val='centered';
			if(dgi('ps').checked) val='stretched';
			if(dgi('pt').checked) val='tiled';
		}
		dgi("doUse").checked=true;
		if(!currentWallpaper) return;
		if(val=='centered') dgi('preview').innerHTML='<img style="position:relative;width:60px;height:40px;top:15px;left:5px" src="'+currentWallpaper+'">';
		if(val=='stretched') dgi('preview').innerHTML='<img style="position:absolute;width:70px;height:70px;top:0px;left:0px" src="'+currentWallpaper+'">'
		if(val=='tiled') dgi('preview').innerHTML='<img style="position:absolute;width:50px;height:40px;top:0px;left:0px" src="'+currentWallpaper+'"><img style="position:absolute;width:50px;height:40px;top:0px;left:51px" src="'+currentWallpaper+'"><img style="position:absolute;width:50px;height:40px;top:41px;left:0px" src="'+currentWallpaper+'"><img style="position:absolute;width:50px;height:40px;top:41px;left:51px" src="'+currentWallpaper+'">';
	}

	</script>
	<?php
	echo outDivFrame('frame1',false,'margin-top:10px');
	echo '<div class="frame1Header">'.outImage(outIcon('wallpaper'),false,false,'margin-right:1em; vertical-align:middle').cfCaption('genWallpaper').'</div>';

	if(file_exists(cfAppDocRoot().'/themes/'.$wpTheme.'/menu.php')) require_once('../themes/'.$wpTheme.'/menu.php');

	// No Wallpaper allowed
	if(isset($theme['hasWallpaper']) && !$theme['hasWallpaper']){
		echo '<div style="width:100%; text-align:center"><br/><br/><span class="warning">'.cfCaption('configNoWallpaper').'</span><br/><br/><br/><br/>';
		echo outBt(cfCaption('genClose'),outIcon('cancel'),'javascript:'.((cfIsInApp())?'parent.openWPForm(\''.$wpTheme.'\')':'winMe.closeMe();'));
		echo '</div>';
	}
	// Upload form
	else{
		// Image upload form
		echo '<form name="wallpaperForm" method="POST" enctype="multipart/form-data" style="margin:0;padding:0">';

		// No image
		echo outDivFrame('frame2');
		echo '<input type="radio" id="noUse" name="useWallpaper" value="no"'.(($wallpaper)?'':' checked="checked"').' onclick="setPosition(\'no\')"><span style="cursor:default" onclick="setPosition(\'no\')">'.cfCaption('configWPNo').'</span><br/>';
		echo '</div>';

		// Send image
		echo outDivFrame('frame2');
		echo '<input type="radio" id="doUse" name="useWallpaper" value="yes"'.((!$wallpaper)?'':' checked="checked"').' onclick="setPosition()"><span style="cursor:default" onclick="setPosition()">'.cfCaption('configSelectWallpaper').'</span><br/><br/>';
		echo '<input type="hidden" name="theme" value="'.$wpTheme.'">';

		// Image selection control
		echo '<input onchange="checkFile();" type="file" id="image" name="image" accept="image/gif,image/jpeg" value="" size=5>';
		echo '<div class="warning">';
		if(isset($incorrectFileType)) echo cfCaption('blogErrorNotImage'); else echo '&nbsp;';
		echo '</div>';
		echo '<div id="preview" style="position:relative;width:70px;height:70px;margin-bottom:20px;float:left;border:1px solid #AAA;overflow:hidden;background:#EEE"></div>';
		// Position selection controls
		echo '<input type="radio" onclick="setPosition(this.value)" id="pc" name="position" value="centered"'.(($wallpaperPosition=='centered')?' checked="checked"':'').'>'.cfCaption('configWPCentered').' &nbsp;';
		echo '<input type="radio" onclick="setPosition(this.value)" id="pt" name="position" value="tiled"'.(($wallpaperPosition=='tiled')?' checked="checked"':'').'>'.cfCaption('configWPTiled').' &nbsp;';
		echo '<input type="radio" onclick="setPosition(this.value)" id="ps" name="position" value="stretched"'.(($wallpaperPosition=='stretched')?' checked="checked"':'').'>'.cfCaption('configWPStretched');
		echo '</div>';
		echo "</form>\n";
		echo '<center>';
		echo outButton(cfCaption('genValidate'),'javascript:D.wallpaperForm.submit();',outIcon('ok'));
		echo outButton(cfCaption('genCancel'),'javascript:'.((cfIsInApp())?'parent.openWPForm(\''.$wpTheme.'\')':'winMe.closeMe();'),outIcon('cancel'),false,false,'style="margin-left:2em"');
	}
	if($wallpaper) echo '<script language="Javascript" type="text/javascript">setPosition("'.$wallpaperPosition.'");</script>';
	echo '</div></body></html>';
}

/**
 * @desc display theme selection Form
 *
 * @param string $environment : 'application' if launched from UI, 'browser' if launched from web browser
 * @param mixed $userFile : - false for general theme
 * 						    - user configuration file name for user theme
 * 							- or user ID for for user theme
 * @param boolean $wallpaperSelection: true to allow user to select wallpaper
 */
function acThemeForm($environment, $userFile=false, $wallpaperSelection=true){
	// Init themes list
	$themes=cfMGetVar('weezoThemes');
	unset($themes['wiizo']); unset($themes['skins/default']); unset($themes['skins/osx']);

	/*
	 ***************************************************************************************************************************
	 * Process POST commands
	 ***************************************************************************************************************************
	 */
	if(isset($_POST['selectedTheme']) && isset($_POST['userFile'])){
		if(($_POST['selectedTheme']=='-' || isset($themes[$_POST['selectedTheme']])) && ($_POST['userFile']=='general' || (file_exists(cfAppDataDir().'/groups/'.$_POST['userFile']) && cfFileExtension($_POST['userFile'])=='usr'))){
			if($_POST['selectedTheme']=='-') $_POST['selectedTheme']='';
			// General theme
			if($_POST['userFile']=='general'){
				cfGUpdateVar('theme',$_POST['selectedTheme']);
			}
			// User theme
			else{
				//Update / save group-level or single-user-level general var
				cfSaveUserVar('theme',$_POST['selectedTheme']);

				require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
				$uc=new WUserConfig($_POST['userFile']);
				if($uc->isValid()){
					// Modify current user config
					if(cfIsInApp()) $uc->setVar('theme',$_POST['selectedTheme']);
					if(WEnv::user()) WEnv::user()->setVar('theme',$_POST['selectedTheme']);
				}
			}
			// Close page (app environement)
			cfInsertHEAD(false);
			if(cfIsInApp()) die('<script type="text/javascript">wl.UIWebPopupReturn("'.$_POST['selectedTheme'].'")</script>');
			echo cfScriptLink('winClient.js');
			die('<script type="text/javascript">winMe.reloadDesktop()</script>');
		}
	}

	/**
	 * Find currently applicable theme
	 */
	$selectedTheme=false;

	// Load parameters
	if($userFile===false || $userFile=='general'){
		$userFile='general';
		$selectedTheme=cfGGetVar('theme');
		$themeLevel='general';
	}
	// subUser-level theme
	elseif(cfFileExtension($userFile)=='usr' && file_exists(cfAppDataDir().'/groups/'.$userFile) && cfUGetVar('subUserId')){
		if(WEnv::user()->subUser()->getGVar('theme')) $selectedTheme=WEnv::user()->subUser()->getGVar('theme');
		$themeLevel='list';
	}
	// Group-level theme
	elseif(cfFileExtension($userFile)=='usr' && file_exists(cfAppDataDir().'/groups/'.$userFile)){
		$userData=cfParse_ini_file(cfAppDataDir().'/groups/'.$userFile);
		if(isset($userData['theme'])) $selectedTheme=$userData['theme'];
		$themeLevel='user';
	}
	else outDisplayErrorPage(cfCaption('configInvalidFile'));

	// Ensure theme file is clean
	$selectedTheme=str_replace('..','',$selectedTheme); if(!is_file(cfAppDocRoot().'/themes/'.$selectedTheme)) $selectedTheme='simple';

	/*
	 ***************************************************************************************************************************
	 * HEAD, CSS & JS
	 ***************************************************************************************************************************
	 */
	cfInsertHEAD(false,array('size'=>'800x550','icon'=>'theme','title'=>cfCaption('genTheme')));
	if(!cfIsInApp()) echo cfScriptLink('winClient.js');
	echo "</HEAD>\n";
	?>
	<style type="text/css">
	.WPIframe{display:none; overflow:hide;margin-left:-15px;margin-right:-15px;margin-top:8px;margin-bottom:-7px;width:220px;padding:-5px}
	.ts {padding:10px;margin:5px; border:1px solid #DDF; background:#F9F9FF;vertical-align:top}
	.tsh{padding:10px;margin:5px; border:1px solid #AAF; background:#DDF;vertical-align:top}

	.tss{padding:10px;margin:5px; border:1px solid #AAF; background:#CCF;vertical-align:top}
	.tssh{padding:10px;margin:5px; border:1px solid #88C; background:#AAD;vertical-align:top}

	.tsc{padding:10px;margin:5px; border:1px solid #AAF; background:#99D;vertical-align:top}

	.thumbnail, .noPreview{border:1px solid #DDD; margin:3px 10px 10px 10px;width:200;height:153}
	#themesTable span{}
	.noPreview{display:block;position:relative;width:200px;height:153px;font-weight:bold;padding-top:70px;text-align:center; background:white;margin:3px 10px 10px 10px;}
	.tsh .noPreview, .tssh .noPreview {border:1px solid #AAA !important}
	{border:1px solid #DDD; margin:10px;}

	</style>
	<script type="text/javascript">
	function hi(item){
		if(item.className=='ts') item.className='tsh'; else item.className='tssh';
	}
	function low(item){
		if(item.className=='tsh') item.className='ts'; else item.className='tss';
	}
	function select(item){
		item.className='tsc';
		dgn("selectedTheme").value=item.id;
		D.themeForm.submit();
	}
	function keyPressed(e) {
		if(wl.eventKC(e)==27){
			<?php
			if(cfIsInApp()) echo 'javascript:wl.UICommand(\'close\')'; else echo 'winMe.closeMe();';
			?>
		}
	}
	function openWPForm(id){
		if(dgi('wallpaper_'+id).style.display=='inline'){
			anim(id, 10, 'close');
			return;
		}
		dgi('wallpaper_'+id).src='/local/wallpaper.php?theme='+id;
		anim(id, 0, 'open');
	}
	function anim(id, step, dir){
		if(step==0 && dir=='open')	dgi('wallpaper_'+id).style.display='inline';
		if(step==10 && dir=='close')	dgi('img_'+id).style.display='inline';
		dgi('wallpaper_'+id).style.height=((step)*26)+'px';
		dgi('img_'+id).style.height=(153*(1-step/10))+'px';
		dgi('img_'+id).style.width='200px';
		if(dir=='open'){
			if(step<10)	window.setTimeout('anim("'+id+'",'+(step+1)+',"open")',10);
			else dgi('img_'+id).style.display='none';
		}
		if(dir=='close') {
			if(step>0) window.setTimeout('anim("'+id+'",'+(step-1)+',"close")',10);
			else dgi('wallpaper_'+id).style.display='none';
		}
	}
	</script>
	<body onKeyPress="keyPressed(event);">
	<form name="themeForm" action="<?php echo $_SERVER['PHP_SELF']; ?>" method="POST" enctype="multipart/form-data" onsubmit="return false;" style="display:none">
	<input type="text" name="userFile" value="<?php echo $userFile;?>">
	<input type="text" name="selectedTheme">
	</form>

	<?php
	echo outDivFrame('frame1');
	echo '<table id="themesTable" class="frame1" style="background:none; border:none; text-align:center" cellspacing="10">';
	$nb=0;

	/**
	 * If group, subUser or resource-level theme, display a "default theme" box
	 */
	if($themeLevel!='general'){
		echo '<tr><td id="-" onmouseover="hi(this)" onmouseout="low(this)" onclick="select(this)" class="'.(($selectedTheme==false)?'tss':'ts').'">';
		if(isset($themes[cfGGetVar('theme')]) && file_exists($themes[cfGGetVar('theme')]['dir'].'/thumbnail.png'))
			$path=$themes[cfGGetVar('theme')]['path'].'/thumbnail.png';
		else
			$path=false;
		echo '<div style="font-weight:bold">'.cfCaption('genDefaultValue').'</div>';
		if($path) echo '<img src="'.$path.'" style="'.outCssOpacity(30).'" class="thumbnail"/><br>';
		else echo '<div class="noPreview">'.cfCaption('genNoPreview').'</div>';

		echo '</td>';
		$nb=1;
	}

	/*
	 ***************************************************************************************************************************
	 * Display themes thumbnails
	 ***************************************************************************************************************************
	 */
	foreach ($themes as $key=>$value) if($key!='wiizo' && $key!='skins/default' && (!isset($value['private']) || !$value['private'])) {
		if($nb%3==0) echo '<tr>';
		if(file_exists($value['dir'].'/thumbnail.png')) $path=$value['path'].'/thumbnail.png'; else $path=false;
		echo '<td id="'.$key.'" onmouseover="hi(this)" onmouseout="low(this)" onclick="select(this)" class="'.(($selectedTheme==$key)?'tss':'ts').'">';
		echo '<div style="margin:0;padding:0">'.ucfirst(cfUTF8Encode($key)).'</div>';
		if($path) echo '<img id="img_'.$key.'" src="'.$path.'" class="thumbnail"/><br>'; else echo '<div id="img_'.$key.'" class="noPreview">'.cfCaption('genNoPreview').'</div>';
		if($wallpaperSelection){
			echo outButton(cfCaption('genWallpaper'),'javascript:openWPForm(\''.$key.'\')',outIcon('wallpaper'));
			echo '<iframe id="wallpaper_'.$key.'" class="WPIframe" frameborder="0"></iframe>';
		}
		echo '</td>';
		$nb++;
		if($nb%3==0) echo '</tr>';
	}
	if($nb%3!=0) echo '</tr>';
	echo '</table>';
}