<?php
/**
 * Files viewer for mobile devices
 *
 * Included by viewFunctions.php, entry point mvfViewFile
 * parameters :
 * - $completeFilename : complete filename of image to view
 * - $data4
 * - $data5
 * - $fileType: 'audio', 'image', 'video', 'text', 'other';
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.3.0
 */



/**
 * @Desc Insert head (for known file types)
 * @param string $completeFilename
 * @param array $options: "standard" options for head / top controls
 *
 */
function mfvInsertHead($completeFilename, $options){
	// Insert HEAD and common scripts and theme
	mfInsertHead($options);
	if(!isset($_POST['asyncRequest'])){
		outInsertStandardComForm($_SERVER['PHP_SELF'],cfUTF8Encode(cfResourceRelativePath(cfRGetVar('efCurrentDirectory'))),cfUTF8Encode(basename($completeFilename)));
	// Common scripts (dl, mAdd)
?>
<script type="text/javascript">
var sS=0,ocS=0;
function dl(n){
wl.liSel(n);
var d=D.comForm.data1.value,f=D.comForm.data2.value,dlt='';
for(var i=0;i<d.length;i++) dlt+=d.charCodeAt(i);
for(var i=0;i<f.length;i++) dlt+=f.charCodeAt(i);
var tu="/dl/dlToken"+dlt+'/resId'+resId+'/'+d+'/'+f;
D.location=tu.replace(/#/gi,"*weezoSharp*").replace(/\&/gi,"*weezoAmp*").replace(/\+/gi,"*weezoPlus*").replace(/\%/gi,"*weezoPercent*").replace(/ /gi,"%20");
setTimeout('us("'+n.id+'")',500);
}
function mAdd(n){wl.liSel(n);fAS(D.comForm.data2.value,'mAdd','','','async');setTimeout('us("'+n.id+'")',500)}
function sF(a,b){fAS(undefined,'view',a,(b)?b:'',true)}
function ocT(){dgi('oc').style.display=(ocS)?'none':'block';dgi('ocTB').className=(ocS)?"bt":"btSel";ocS=1-ocS}</script>
<?php
		echo '<div class="frame1Header" id="name">'.cfUTF8Encode(cfFileWithoutExtension(basename($completeFilename))).'</div>';
	}
}

/**
 * @desc VIEW FILE IN A DEDICATED WINDOW
 * 		specific file types :
 * 		- audio (vfViewFileAudio)
 * 		- video (vfViewFileVideo)
 * 		- image (vfViewFileImage)
 * 		- text (vfViewFileText)
 * Note : parameters have previously been utf-8 decoded
 *
 * @param string $completeFilename : path and filename of file to view
 * @param string $data3
 * @param string $data4
 * @param string $data5
 * @return unknown
 */
function mvfViewFile($completeFilename, $data4=false, $data5=false, $fileType=false){
	global $options;
	global $optionsControls;
	require_once(INCLUDE_DIR.'mobileFunctions.php');

	$options=array('context'=>'view');
	$optionsControls='';

	// Main controls
	$controls='';
	if($fileType=='image'){
		$controls.='<center>';
		$optionsControls.=mfButton(false,'javascript:sBt()',outIcon('slide'),'id="sBt"').'&nbsp;';
		$controls.=mfButton(false,'javascript:prevBt()',outIcon('left'),'id="pBt"');
		$controls.=mfButton(false,'javascript:nextBt()',outIcon('right'),'id="nBt"');
		$controls.='</center>';
		$options['topControlsLabel']=$controls;
		$options['bodyExtraHTML']='onload="init()"';
	}

	// Extra controls (download, multiple download)
	if(cfCmpLeft($completeFilename,'webcam:')) {
		$rights=array('download'=>false);
		$fileType='video';
	}
	else $rights=cfFileRights($completeFilename);

	if($rights['download']) {
		$optionsControls.=mfButton(false,'javascript:dl(this)',outIcon('dl'));
		if(cfRGetVar('multipleDownloadAllowed')) $optionsControls.=mfButton(false,'javascript:mAdd(this)',outIcon('mdl'));

	}
	if($optionsControls)
		$options['topControlsExtra']=mfButton(false,'javascript:ocT(this)',outIcon('medPlus'),'id="ocTB"');

	cfLogContentAccess($completeFilename);
	switch ($fileType){
		case 'image':
			mvfViewFileImage($completeFilename,$data4,$data5);
		break;
		case 'audio':
			mvfViewFileAudio($completeFilename,$data4,$data5);
		break;
		case 'video':
			mvfViewFileVideo($completeFilename,$data4,$data5);
		break;
		case 'text':
			return mvfViewFileText($completeFilename, $data4, $data5);
		break;
		// Other files formats
		default:
			// JS file : treat as text file
			if(efFileMimeType($completeFilename)=='application/x-javascript') return mvfViewFileText($completeFilename, $data4, $data5);

			header('Content-Type:'.efFileMimeType($completeFilename));
			header('Content-Disposition:inline; filename="'.cfUTF8Encode(basename($completeFilename))).'"';
			header('Content-Length: '.cfFileSize($completeFilename));
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0, public");
			header("Expires: 0");

			wSession_write_close();
			cfStreamFile($completeFilename,false,'auto');
			exit;
	}
}

/**
 * @desc View a text file
 *
 * @param string $completeFilename
 * @param string $data4
 * @param string $data5
 */
function mvfViewFileText($completeFilename, $data4, $data5){
	global $options;
	global $highlighted;
	wSession_write_close();
	// Insert head
	mfvInsertHead($completeFilename, $options);

	// Known formats
	if(isset($highlighted[cfFileExtension($completeFilename)])){
		require_once(INCLUDE_DIR.'Text/Highlighter.php');
		$hl =& Text_Highlighter::factory($highlighted[cfFileExtension($completeFilename)]);
		?>
<style type="text/css">
.hl-bg{font-size:9px;background:white;color:black}
.hl-main{font-family:monospace;}
.hl-gutter{background-color:#CCCCCC;padding-right:10px;font-family:monospace;}
.hl-table{border:solid1px#000000;}
.hl-default{color:#000000;}
.hl-code{color:#7f7f33;}
.hl-brackets{color:#009966;}
.hl-comment{color:white;background:#AAF}
.hl-quotes{color:#00007F;}
.hl-string{color:#009900;}
.hl-identifier{color:#000000;}
.hl-reserved{color:#0000FF;}
.hl-inlinedoc{color:#EEF;background:#AAF}
.hl-var{color:#CC3300;}
.hl-url{color:#FF0000;text-decoration:underline}
.hl-special{color:#0000FF;}
.hl-number{color:#007F00;}
.hl-inlinetags{color:#FF0000;}
.tooltip.hl-main,.tooltip.hl-gutter{font-size:8px!important;font-size:10px}
</style>
<?php
		echo '<div class="hl-bg">'.cfUTF8Encode($hl->highlight(file_get_contents($completeFilename)),false,false).'</div>';
	}
	// Other : display as plain text
	elseif($fp=@fopen($completeFilename,'r')) {
		fclose($fp);
		echo '<pre>'.str_replace('<','&lt;',cfUTF8Encode(file_get_contents($completeFilename))).'</pre>';
	}
}

/**
 * @desc View an image
 *
 * @param string $completeFilename
 * @param string $data4
 * @param string $data5
 */
function mvfViewFileImage($completeFilename,$data4,$data5){
	global $options;
	global $optionsControls;

	// Insert head
	mfvInsertHead($completeFilename, $options);

	// Synchronous call: insert scripts and HTML, and exit
	if(!cfIsAsync()){
		if($optionsControls) echo '<div id="oc" style="display:none" class="frame1">'.$optionsControls.'</div>';
		?>
<script type="text/javascript">
var cI=2;
var sAH;
var sAW;
var ctrlH=<?php if(cfBGetVar('name')=='IEMobile') echo IEMOBILE_TOP_CONTROLS_HEIGHT; else echo '0';?>;
var vIZ=<?php echo (int)cfRGetVar('viewImageZoom');?>;
var iNb=0;
var imgH;
function nextBt(){
	if(mcRIP) return;
	if(sS) clearTimeout(sS);
	wl.liSel(dgi('nBt'))
	sF('next');
	setTimeout('us("nBt")',300);
}
function sBt(){
	if(!sS){
		wl.liSel(dgi('sBt'));
		ocT();
		sS=setTimeout(nextBt,<?php echo (((cfRGetVar('slideShowInterval'))?cfRGetVar('slideShowInterval'):4)*1000);?>)
	}
	else {
		clearTimeout(sS);
		sS=0;
		wl.liUnsel(dgi('sBt'));
	}
}
function prevBt(){
	if(mcRIP) return;
	if(sS) window.clearTimeout(sS);
	wl.liSel(dgi('pBt'))
	sF('prev');
	window.setTimeout('us("pBt")',300);
}
function tg(){
<?php if(cfBGetVar('name')=='IEMobile') echo 'return;'; else{?>
	if(sS) sBt();
	vIZ=1-vIZ;
	init();
<?php } ?>
}
function iH(n){with(n.style){height='1px';visibility='hidden'}}
function iS(n){with(n.style){height='';visibility='visible'}}
function iL(){
	n=dgi('tmp');
	if(!n.src) return;
	if(dgi('tmp2')) dgi('imgc').removeChild(dgi('tmp2'));
	n.id='tmp2';
	iS(n);
	//dgi("sp").style.height=Math.floor(Math.max(0,((sAH-dgi('imgc').offsetTop-imgH-ctrlH)/2)))
	if(sS) sS=W.setTimeout(nextBt,<?php echo (((cfRGetVar('slideShowInterval'))?cfRGetVar('slideShowInterval'):4)*1000);?>)
}
function setImg(u,l,w,h,p,t){
	dgi('name').innerHTML=l;
	//dgi('name').innerHTML='se:'+sAH+" h:"+h+" ot:"+dgi('imgc').offsetTop+" iNb:"+iNb;
	D.comForm.data2.value=l;
	imgH=h;
	i=D.createElement('img');
	i.id="tmp";
	i.onload=iL;
	iH(i);
	dgi('imgc').appendChild(i);
	i.src=u;
}
function imgClick(event){
	var p=event.clientX/dgi('imgc').offsetWidth;
	if(p>0.7) nextBt();
	else if(p<0.3) prevBt();
	else tg();
}
function mon(){if(screen.availHeight!=sAH) init();	else setTimeout('mon()',500);}
function init(){
	sAH=screen.availHeight; sAW=screen.availWidth;
	//alert("ok"+sAW+" - "+dgi('imgc').offsetTop)
	sF('setTop',(dgi('imgc').offsetTop+ctrlH)+"/"+sAW+"/"+sAH+"/"+vIZ);
	mon();
}
</script>
<center id="imgc" onclick="imgClick(event)">
<div id="sp" style="position:relative;display:block;overflow:hidden;height:10px"></div>
</center>
		<?php

		// Get/Set viewport dimensions
		if($data4=='firstLoad' && preg_match('/^[0-9]{2,4}x[0-9]{2,4}$/',$data5)) {
			list($w,$h)=explode('x',$data5);
			cfGSetVar('userScreenWidth',$w);
			cfGSetVar('userScreenHeigth',$h);
		}
		exit;
	}

	// Get image top coordinates, used for size and top-margin computing, as well as screen available space and zoom state
	if($data4=='setTop'){
		@list($t,$w,$h,$viewImageZoom)=explode('/',$data5);
		if(is_numeric($t)&&is_numeric($h)&&is_numeric($h)&&is_numeric($viewImageZoom)){
			cfGSetVar('viewImgTop',$t);
			cfGSetVar('userScreenWidth',$w);
			cfGSetVar('userScreenHeigth',$h);
			cfRSetVar('viewImageZoom',$viewImageZoom); // 0: fit to screen, 1: 3x screen size
		}
	}

	$requiredScript=true;
	require(INCLUDE_DIR.'viewImageFunctions.php');

	// Set available space for image
	$w=cfGGetVar('userScreenWidth')-20*0; // Remove arbitray 20px for scrollbar... err finally, don't
	$h=cfGGetVar('userScreenHeigth')-cfGGetVar('viewImgTop')*0; // Remove HTML top controls... err finally, don't

	// If zoom image, 3x enlarge
	if(cfRGetVar('viewImageZoom')) {$w*=3;$h*=3;}

	// Go to next/prev image
	if($data4=='next') $completeFilename=findContiguousFile($completeFilename,'next','image',false,$pos,$total);
	elseif($data4=='prev') $completeFilename=findContiguousFile($completeFilename,'previous','image',false,$pos,$total);
	else{
		// Compute current file's position
		$files=efGetDirContent(cfDirName($completeFilename),false,false,'image',true,array('noExtra'=>1));
		$total=$files['nbFiles'];
		$pos='""';
		foreach ($files as $k=>$v) if(isset($v['completeFileName']) && $v['completeFileName']==$completeFilename)
			{$pos=$k;break;}
	}

	// Compute output image dimensions
	list($iw,$ih)=getImageDimensions($completeFilename);
	list($tnw,$tnh)=cfThumbnailDimensions($iw,$ih,$w,$h,false);

	echo cfAsyncXMLJSaction('setImg("'.cfExtImage($completeFilename,$tnw,$tnh).'","'.cfUTF8Encode(basename($completeFilename)).'",'.$tnw.','.$tnh.','.$pos.','.$total.')');
	echo cfAsyncFooter();
	exit;
}

/**
 * @desc Play an audio file
 *
 * @param string $completeFilename
 * @param strinf $data4
 * @param string $data5
 */
function mvfViewFileAudio($completeFilename,$data4,$data5){
	global $options;
	global $optionsControls;

	// Embeded player (not supported yet)
	if(0&&!cfBGetVar('standaloneMediaPlayer')) {
		// Insert head
		mfvInsertHead($completeFilename, $options);
		die('standaloneMediaPlayer not supported</body></html>');
	}

	// Set bitrate
	$outputBitRate=cfBitrateMin(cfRGetVar('outputBitRate'),cfBGetVar('maxAudioBitrate'));
	if(!$outputBitRate) $outputBitRate=MOBILE_DEFAULT_AUDIO_BITRATE;

	// Playlist not supported: send file to browser
	if(!cfBGetVar('playlistFormat')){
		$link=cfExtAudio($completeFilename,'audio/'.$outputBitRate.'/');
		header('Location: '.$link);
		exit;
	}

	// ASX formated playlist (old windows phones)
	if(cfBGetVar('playlistFormat')=='asx'){
		require_once(INCLUDE_DIR.'fileInfoFunctions.php');

		// Generate ASX playlist
		$asxPlaylist=fiArrayToPlaylist(fiParsePlaylistFile($completeFilename,true,true),'asx',array('outputBitRate'=>$outputBitRate),'absolute');
		if($completeFilename=='*playlist*.m3u') $completeFilename=cfCaption('explorerAudioPlaylist').'.asx';
		header('Content-Type: video/x-ms-asf');
		header('Content-Disposition: inline; filename="'.cfUTF8Encode(cfFileWithoutExtension(basename($completeFilename)),false,false).'.asx"');
		header('Content-Length: '.strlen($asxPlaylist));
		header("Cache-Control: no-cache, no-store, must-revalidate, private");
		header("Expires: 0");

		cfDebugSetBuffer('sync',$_POST,$asxPlaylist);
		die($asxPlaylist);
	}


	// Flash player
	if(0&&cfBGetVar('flash')){
		$args='&bufferSize='.((cfRGetVar('flashPlayerBufferLength'))?cfRGetVar('flashPlayerBufferLength'):'3').'&autoplay=1&volume='.((cfRGetVar('flashPlayerDefaultVolume'))?cfRGetVar('flashPlayerDefaultVolume'):'70').'&browser='.cfGetBrowser().'&rnd='.rand();

		// Send page
		mfInsertHead(array('context'=>'view'));
		echo '<center style="margin-top:20%">';
		if(cfGGetVar('userScreenWidth')>600)
			echo vfInsertAudioPlayer($completeFilename,'normal',true,'70%','50%','flash');
		else
			echo vfInsertAudioPlayer($completeFilename,'mobile',true,'50%','50%','flash');
		echo '</center></body>';
		exit;
	}

	// Joined mp3's playlists or flash player
	if(cfBGetVar('playlistFormat')=='joinedfiles'){ // Generic value for android phones
		// Single file: just redirect to mp3
		if(is_file($completeFilename)){
			$link=cfExtAudio($completeFilename,'audio/'.$outputBitRate.'/');
			//header('Location: '.$link);
		}
		// Playlist
		else{
			$link=cfExtAudio($completeFilename,'audio/'.$outputBitRate.'/');
			cfDebugSetBuffer('sync',$_POST,'Joined files playlist, redirect to '.$link);
			//header('Location: '.$link);
		}

		// Head and "back" button
		mfInsertHead(array('topControlsExtra'=>mfButton(false,'javascript:D.location.href=\''.(WEnv::res()->resourceBaseURL()).'\'',outIcon('back'))));

?>
<body onload="init()">
<script type="text/javascript">
function init(){
	if(wl.hasFlash()){dgi('v1').style.display='none'}
	else {
		dgi('playerAudio').style.display='none';
		setTimeout(function(){var v=dgi('playerAudioHtml5'); if(!v || !v.play) D.location="<?php echo $link; ?>"},10)
	}
	winResized();
}
function inlineUpdatePlayerInfo(ref){wl.asr.send({'data2':ref,'data3':'inlineUpdatePlayerInfo'})}
function flashCommand(c,cfn){fAS(cfn,'inlineUpdatePlayerInfo')}
function inlineSetSongPlayed(imgSrc,artist,album,title){
	dgi('inlinePlayerImg').src=imgSrc;
	dgi('inlineArtist').innerHTML=artist;
	dgi('inlineAlbum').innerHTML=album;
	dgi('inlineTitle').innerHTML=title;
}
function winResized(){
	var w=Math.min(screen.availableWidth,screen.height)*0.6,s=dgi('inlinePlayerImg').style;
	s.width=s.height=w+'px';
}
</script>
<center>
<img id="inlinePlayerImg" style="width:50%" src="data:image/gif;base64,<?php echo chunk_split(base64_encode(file_get_contents(cfAppDocRoot().outIcon('v1.gif'))));?>">
</center>
<?php
echo mfListTable();

echo mfListSpacer(cfCaption('explorerAudioArtist'));
echo mfListItem(false,outImage(outIcon('user'),false,'class="nfrLi32"'),false,'<div class="lit" id="inlineArtist">.</div>');

echo mfListSpacer(cfCaption('explorerAudioAlbum'));
echo mfListItem(false,outImage(outIcon('album32'),false,'class="nfrLi32"'),false,'<div class="lit" id="inlineAlbum">.</div>');

echo mfListSpacer(cfCaption('explorerAudioTitle'));
echo mfListItem(false,outImage(outIcon('track32'),false,'class="nfrLi32"'),false,'<div class="lit" id="inlineTitle">.</div>');
echo '</table>';

?>
<center>
<?php
require_once(INCLUDE_DIR.'viewFunctions.php');
echo vfInsertAudioPlayer($completeFilename,'normal',true,'100%','60px','auto');
outInsertStandardComForm($_SERVER['PHP_SELF'],cfUTF8Encode(cfResourceRelativePath(cfRGetVar('efCurrentDirectory'))));
?>
</center>
</body>
<?php
		exit;
	}
}

/**
 * @desc Play a video file - send ASX playlist
 *
 * @param string $completeFilename
 * @param strinf $data4
 * @param string $data5
 */
function mvfViewFileVideo($completeFilename,$data4,$data5,$videoOptions=false){
	global $options; // top controls options
	global $optionsControls;

	if(!is_array($videoOptions)) $videoOptions=array();

	// iPhone video Streaming
	if(cfBGetVar('qtReenc')) mvfInsertVideoPlayerIPhone($completeFilename);

	// Flash player (h264)
	if(cfFfmpegVersion()=='GPL' && cfBGetVar('flash')) mvfInsertVideoPlayerFlash($completeFilename,$data4,$data5,$videoOptions=false);

	// Embeded player (not supported yet)
	if(!cfBGetVar('standaloneMediaPlayer')) {
		// Insert head
		mfvInsertHead($completeFilename, $options);
		die('</body></html>');
	}

	// ASX formated playlist
	if(cfBGetVar('playlistFormat')=='asx'){
		require_once(INCLUDE_DIR.'fileInfoFunctions.php');

		// Compute output video dimensions
		@list($w,$h)=explode('x',$_POST['data5']);
		require_once(INCLUDE_DIR.'viewVideoFunctions.php');
		list($vw,$vh)=vvfVideoDimensions($completeFilename,true);
		list($ow,$oh)=cfThumbnailDimensions($vw,$vh,$w,$h,false);

		$encodingOptions=array('w'=>$ow, 'h'=>$oh, 'q'=>cfRGetVar('flashOutputQuality'), 'wmv'=>'1');

		// Generate ASX playlist
		$asxPlaylist=fiArrayToPlaylist(fiParsePlaylistFile($completeFilename,true,true), 'asx', $encodingOptions, 'absolute');

		//header('Content-Type: video/x-ms-asf');
		header('Content-Disposition: inline; filename="'.cfUTF8Encode(basename($completeFilename),false,false).'"');
		header('Content-Length: '.strlen($asxPlaylist));
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0, public");
		header("Expires: 0");
		die($asxPlaylist);
	}

	require_once(INCLUDE_DIR.'viewVideoFunctions.php');

	// HTML5 video player
	$videoOptions['videoPlayer']='html5Auto';
	vfvViewVideo($completeFilename,@$_POST['data4'],@$_POST['data5'],$videoOptions);
	return;

	// Non iPhone and non Windows Mobile, browser not supporting flash: display no-flash error page
	mfDisplayErrorPage('',outImage(outIcon('flash32')),true);
}



/**
 * @desc insert iPhone player, and start playing (if autostart is set to true)
 *
 * @param string $completeFilename : complete file name of file to play
 */
function mvfInsertVideoPlayerIPhone($completeFilename){

	$sourceLink=cfExtVideo($completeFilename,array('format'=>'m3u8sa'),'relative');

	$quality=cfRGetVar('videoIPhoneQuality'); if(!$quality) $quality='medium';

	// Compute max output quality
	$maxQuality='low';
	$os=cfRGetVar('flashOutputSizeMax'); if($os=='original') $os=9999;
	// Intermediate bitrate
	if($os>160 && cfRGetVar('flashOutputQualityMax')!='low'){
		$maxQuality='medium';
		// High bitrate
		if($os>320 && cfRGetVar('flashOutputQualityMax')!='medium') $maxQuality='high';
	}

//	$sourceLink=cfExtVideo($completeFilename,array('format'=>'m3u8sa','bandwidth'=>$quality),'relative');
	$sourceLink=cfExtVideo($completeFilename,array('format'=>'m3u8','bandwidth'=>$quality),'relative');


	$options = array('topControlsExtra'=>mfButton('','javascript:D.location=\'/res/'.cfRGetVar('type').'/'.cfRGetVar('subType').'/index.php\'',outIcon('back')));

	// Extra top controls forced by resource, replace back button
	if(class_exists('VVOptions')){
		if(VVOptions::getMobileTopControlsExtra()) $options['topControlsExtra']=VVOptions::getMobileTopControlsExtra();
	}

	// Insert head
	if(!($videoName=cfRGetVar('vvfForcedVideoName'))) $videoName=cfUTF8Encode(basename(cfFileWithoutExtension($completeFilename)));
	mfvInsertHead($videoName, $options);


?>
<script type="text/javascript">
<?php if($maxQuality=='low') {echo 'D.location="'.$sourceLink.'"</script>';return;}?>
function setQuality(q){
	var b="<?php echo cfExtVideo($completeFilename,array('format'=>'m3u8','bandwidth'=>'BANDWIDTH','iPhoneRedirectPage'=>'RAND'),'relative')?>";
	wl.liSel(q+'Bt');
	W.open(b.replace(/BANDWIDTH/,q).replace(/RAND/,Math.random()));
}
</script>
<div style="text-align:center">
<?php
	// Quality selection controls
	echo mfListTable();
	echo mfListItem(false,outImage(outIcon('v'),false,'class="nfrLi32"'),false,'<span class="lits">'.cfCaption('genQuality').'</span>');
	echo mfListSpacer();

//	$playerTemplate='<video src="'.cfExtVideo($completeFilename,array('format'=>'m3u8','bandwidth'=>'BANDWIDTH'),'relative').'" style="width:64px;height:32px">';
$playerTemplate=outImage(outIcon('go'));

	// Low quality
	echo mfListItem('id="lowBt" onclick="setQuality(\'low\')"',outImage(outIcon('qualityLow'),false,'class="nfrLi32"'),false,'<span class="lit">'.cfCaption('genLow').'</span>',false,'go');
	// Medium quality
	echo mfListItem('id="mediumBt" onclick="setQuality(\'medium\')"',outImage(outIcon('qualityMedium'),false,'class="nfrLi32"'),false,'<span class="lit">'.cfCaption('genMedium').'</span>',false,'go');
	// High quality
	if($maxQuality=='high') echo mfListItem('id="highBt" onclick="setQuality(\'high\')"',outImage(outIcon('qualityHigh'),false,'class="nfrLi32"'),false,'<span class="lit">'.cfCaption('genHigh').'</span>',false,'go');
	echo '</table>';
	exit;
}


/**
 * @desc insert flash player for mobile devices
 *
 * @param string $completeFilename : complete file name of file to play
 */
function mvfInsertVideoPlayerFlash($completeFilename,$data4,$data5){
	require_once(INCLUDE_DIR.'viewVideoFunctions.php');

	if(!cfIsWII()) cfRSetVar('forceInlinePlayer',1); // Force inline flash player

	vfvViewVideo($completeFilename,$data4,$data5);
	exit;
}