<?php
/**
 * SMTP server configuration
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 3.0.L
 */

require_once(INCLUDE_DIR.'mailFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');

/**
 * @desc Process commands
 *
 */
function sendMailProcessPost(){
	if(!cfIsAsync() && count($_POST)){
		if(!preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])+@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/",$_POST['destAddress'])) die('incorrect dest address');

		$res=Mailout::sendMail($_POST['destAddress'],cfUTF8Decode($_POST['subject']),cfUTF8Decode($_POST['mailBody']));

		// If an error occured sending mail
		if($res!==true) outDisplayErrorPage(outImage(outIcon('mailOutError')).'<br>'.$res);

		// All ok: close form
		cfInsertHEAD();
?>
<script type="text/javascript">
wl.UIWebPopupReturn();
</script>
<?php
	}
	elseif(cfIsAsync()){
		cfAsyncHeader();
		die(cfAsyncFooter());
	}
}

/**
 * @desc Display mail form
 *
 */
function sendMailDisplayPage(){

	cfInsertHEAD(true,array('size'=>'400x346','icon'=>'mailOut','title'=>cfCaption('userInvite')));

	$mailoutConfig=Mailout::getMainConfiguration();

?>
<body>
<div style="margin-left:5%">
<form name="mailForm" method="POST">
<div class="frame2Header"><?php echo cfCaption('explorerFileSendReceiver')?></div>
<input type="text" name="destAddress" class="textInput" style="width:95%" value="<?php echo @$_GET['destAddress'] ?>"><br>
<br>
<div class="frame2Header"><?php echo cfCaption('genTitle')?></div>
<input type="text" name="subject" class="textInput" style="width:95%" value="<?php echo @$_GET['subject'] ?>"><br>
<br>
<div class="frame2Header"><?php echo cfCaption('explorerFileSendMessage')?></div>
<textarea name="mailBody" class="textInput" style="width:95%;height:170px;overflow:auto"><?php echo str_replace('<br>',"\n",@$_GET['body']) ?></textarea><br>
<br>
</form>
<center>
<?php
echo outBt(cfCaption('genCancel'),outIcon('cancel'),'javascript:MailForm.cancel()',false,false,'style="margin-right:3em"');

echo outBt(cfCaption('genSend'),outIcon('mailOut'),'javascript:MailForm.send()','sendBt');
?>
</center>
</div>
<script type="text/javascript">
var MailForm={
	init:function(){
		$('destAddress').focus();
		$('destAddress').e.connect('keyup',MailForm.validate)
		$('subject').e.connect('keyup',MailForm.validate)
		$('mailBody').e.connect('keyup',MailForm.validate)
		MailForm.validate();
	},
	proceed:function(){
		$('mailoutConfigFrame').e.remove();
		MailForm.init();
	},
	validate:function(){
		var reg=new RegExp('^[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*@[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*[\.]{1}[a-z]{2,6}$', 'i');
		if(!reg.test($('destAddress').value) || !$('subject').value || !$('mailBody').innerHTML){
			btDisable('sendBt');
		}
		else btEnable('sendBt');
	},
	send:function(){
		$(D.mailForm).e.submit();
	},
	cancel:function(){
		wl.UIWebPopupReturn();
	}
}
</script>
<?php
	if(!$mailoutConfig){
?>
<iframe id="mailoutConfigFrame" src="/local/mailConfigForm.php" style="width:100%;height:100%;top:0;left:0;position:absolute;border:0"></iframe>
<?php
	}
	else echo '<script type="text/javascript">MailForm.init();</script>';
	die('</body>');
}



sendMailProcessPost();

sendMailDisplayPage();

?>