<?php
/**
 * IP restriction message boxes
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.0.0
 */


/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
function processPOST(){
	$basePath=cfAppDocRoot().'/gfx/res/';

	// Add a new icon
	if(isset($_POST['addIcon']) && file_exists($cfn=cfUTF8Decode(str_replace('\\','/',$_POST['addIcon'])))){

		cfAsyncHeader();

		// Set new icon's name
		$nb=100; while (file_exists($basePath.$nb.'.png')) $nb++;

		list($w, $h, $type, $attr) = @getimagesize($cfn);

		$basename16=cfAppDocRoot().'/gfx/res/'.$nb.'_16.png';
		$basename32=cfAppDocRoot().'/gfx/res/'.$nb.'.png';


		if($w&&$h){
			$srcImage=imagecreatefromstring(file_get_contents($cfn));
			$pngImage16=imagecreatefrompng(cfAppDocRoot().'/gfx/w0-16.png');
			imagesavealpha($pngImage16,true);
			imageantialias($pngImage16,true);
			imagecopyresampled($pngImage16,$srcImage,0,0,0,0,16,16,$w,$h);
			imagepng($pngImage16,$basename16);

			// Resample / reencode image
			if($w!=32 || $h!=32 || cfFileExtension($cfn)!=='png'){
				// Destination image: create from transparent png
				$pngImage32=imagecreatefrompng(cfAppDocRoot().'/gfx/w0-32.png');
				imagesavealpha($pngImage32,true);
				imageantialias($pngImage32,true);

				// Resized source image
				$resizedImage=imagecreatefrompng(cfAppDocRoot().'/gfx/w0-32.png');
				$rs=min($w,$h);
				imagecopyresampled($resizedImage,$srcImage,0,0,($w-$rs)/2,($h-$rs)/2,32,32,$rs,$rs);

				$glowImage32=imagecreatefrompng(cfAppDocRoot().'/gfx/glow32.png');

				// Copy source to target with artificial rounded corners
				imagecopyresampled($pngImage32,$resizedImage,2,0,2,0,28,32,28,32);
				imagecopyresampled($pngImage32,$resizedImage,1,1,1,1,30,30,30,30);
				imagecopyresampled($pngImage32,$resizedImage,0,2,0,2,32,28,32,28);

				// Add glow
				imagecopyresampled($pngImage32,$glowImage32,0,0,0,0,32,32,32,32);

				// Save 32x32 image
				imagepng($pngImage32,$basename32);

				imagedestroy($resizedImage);
				imagedestroy($pngImage32);

				// Re-build 16x16 image
				$pngImage16=imagecreatefrompng(cfAppDocRoot().'/gfx/w0-16.png');
				imagesavealpha($pngImage16,true);
				imageantialias($pngImage16,true);
				$resizedImage=imagecreatefrompng(cfAppDocRoot().'/gfx/w0-16.png');
				imagecopyresampled($resizedImage,$srcImage,0,0,($w-$rs)/2,($h-$rs)/2,16,16,$rs,$rs);

				// Copy source to target with artificial rounded corners
				imagecopyresampled($pngImage16,$resizedImage,1,0,1,0,30,32,30,32);
				imagecopyresampled($pngImage16,$resizedImage,0,1,0,1,32,30,32,30);

				// Add glow
				imagecopyresampled($pngImage16,$glowImage32,0,0,0,0,16,16,32,32);

				// Save 16x16 image
				imagepng($pngImage16,$basename16);
			}

			// Image is already a 32x32 png: just copy
			else copy($cfn,$basename32);

			echo cfAsyncJSaction('selectImage('.$nb.')');
		}
		die(cfAsyncFooter());
	}

	// Remove an icon
	if(isset($_POST['removeIcon']) && is_numeric($_POST['removeIcon']) && $_POST['removeIcon']>=100 && file_exists($basePath.$_POST['removeIcon'].'.png')){
		@unlink($basePath.$_POST['removeIcon'].'.png');
		@unlink($basePath.$_POST['removeIcon'].'_16.png');

		cfAsyncHeader();
		echo cfAsyncJSaction('wl.goURL()');
		die(cfAsyncFooter());
	}
}


if(!cfIsInApp()) die('Unauthorized access');

require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'explorerFunctions.php');

// Check passed resource type and subtype (used for default icon)
if(!isset($_GET['resType']) || !isset($_GET['resSubType']) || !isset($_GET['currentIcon'])) die('Incorrect parameters (1)');
$type=cfSanitizeFile($_GET['resType']);
$subType=cfSanitizeFile($_GET['resSubType']);
if(!is_dir(cfAppDocRoot().'/res/'.$type.'/'.$subType)) die('Incorrect parameters (2)');

// Get default icon
$defRes=new WResDefinition($type,$subType);
$defaultIcon=$defRes->icon32();

processPOST();

/*
 ***************************************************************************************************************************
 * Display page
 ***************************************************************************************************************************
 */
cfInsertHEAD(false,array('size'=>'600x550'));
?>
<script type="text/javascript">
var cancelClick;
function browseImages(){wl.UICommand('openFile','*.jpg;*.jpeg;*.gif;*.bmp;*.png:selectedImage')}
function browseImagesProceed(cfn){wl.asr.send({'addIcon':cfn})}
function cancel(){wl.UICommand('close')}
function selectImage(nb){if(!cancelClick) wl.UICommand('close',nb)}
function removeImage(nb){cancelClick=1;wl.asr.send({'removeIcon':nb})}
</script>
</head>
<body style="overflow:hidden">
<input name="selectedImage" onkeyup="browseImagesProceed(this.value)" style="display:none">
<?php
echo outDivFrame('frame1');
echo outFrameHeaderTable('frame1Header',outImageIcon('chat').cfCaption('userIcon'),outButton(cfCaption('genAdd'),'javascript:browseImages()',outIcon('new')));

echo '<center><div class="frame2" style="width:590px;height:480px;overflow:auto;margin-top:0.5em;margin-bottom:0.5em;text-align:left">';

// List icons
foreach (cfGlob(cfAppDocRoot().'/gfx/res/*.*') as $cfn) {
	if(efFileType($cfn)=='image' && !strpos($cfn,'_16')) $list[$cfn]=filectime($cfn);
}
// Revert-sort by creation date
arsort($list);

$resIcon='default';

/**
 * Display icons
 */

// Default resource icon
echo outBlockItem('userIcons',outImage($defaultIcon),'id="uI0"','width:40px;height:40px;padding:10px',array('onclick'=>"selectImage('0')"),(($_GET['currentIcon']==0)?'sel':'unsel'));

// Other icons
foreach ($list as $cfn=>$cdate){
	$id=basename(cfFileWithoutExtension($cfn));
	if(is_numeric($id) && $id>=100)
		$suppBt='<img src="'.outIcon('cancelVSNarrow').'" alt="" id="suppBt'.$id.'" onmousedown="removeImage(\''.$id.'\')" title="'.cfCaption('genClear').'" style="position:absolute;right:1px;top:-3px;display:none">';
	else
		$suppBt='';

	echo outBlockItem(
		'userIcons',
		outImage('/gfx/res/'.basename($cfn)).$suppBt,'id="uI'.basename($cfn).'"','width:40px;height:40px;padding:10px',
		array(
			'onclick'=>"selectImage('".$id."')",
			'onmouseover'=>"if(dgi('suppBt".$id."')) dgi('suppBt".$id."').style.display=''",
			'onmouseout' =>"if(dgi('suppBt".$id."')) dgi('suppBt".$id."').style.display='none'"
		),
		((str_replace('.png','',basename($cfn))==$_GET['currentIcon'])?'sel':'unsel')
	);
}
echo '</div>';

// OK & Cancel buttons
echo outBt(cfCaption('genCancel'),outIcon('cancel'),'javascript:cancel()',false,false,false,'up',120);
?>
</center>
</div>
</body>