<?php
/**
 * Accounts remote configuration
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
*
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.0.0
 */


/**
 * @desc Return link for config window
 *
 * @param unknown_type $scriptName
 * @param unknown_type $caption
 * @param unknown_type $smallIcon
 * @param unknown_type $w
 * @param unknown_type $h
 * @return unknown
 */
function link2($scriptName,$caption,$smallIcon,$w=320,$h=320){
	return "cw=winMe.openWindow('".dirname($_SERVER['PHP_SELF']).'/'.$scriptName."',{".
		"'id':'".$scriptName."',".
		"'caption':'".addslashes($caption)."',".
		"'w':".$w.",".
		"'h':".$h.",".
		"'noAnimation':1,".
		"'icon':'".$smallIcon."'})";
}

require(INCLUDE_DIR.'outputFunctions.php');

cfInsertHEAD();

$items=array();
	// General parameters (windows, language)
	$items[]=array('link'=>link2('windows.php',cfCaption('desktop'),outIcon('win'),340,350),'image'=>outIcon('winM'),'caption'=>cfCaption('desktop'));
	// Password
	if(cfUGetVar('accountType')=='singleUser' || cfUGetVar('accountType')=='list') $items[]=array('link'=>link2('password.php',cfCaption('genPassword'),outIcon('lock'),320,170),'image'=>outIcon('pwdM'),'caption'=>cfCaption('genPassword'));
	// Theme
	if(cfGGetVar('allowUserThemeChange'))
		$items[]=array('link'=>link2('theme.php',cfCaption('genTheme'),outIcon('theme'),840,600),'image'=>outIcon('themeM'),'caption'=>cfCaption('genTheme'));
	// Wallpaper
	if(cfUGetVar('accountType')=='singleUser') $items[]=array('link'=>link2('wallpaper.php',cfCaption('genWallpaper'),outIcon('wallpaper'),420,400),'image'=>outIcon('wallpaperM'),'caption'=>cfCaption('genWallpaper'));

echo '<div style="vertical-align:top">';
echo outIconsList($items);
echo outKeyHandler('D',array('27'=>'winMe.closeMe()'),true);
?>
</div></body>