<?php
/**
 * DOS Prompt
 *
 * this script is included by index.php and shouldn't be directly called
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */


/**
 * @desc Display mobile prompt page
 *
 */
function promptDisplayMobilePage(){
	require_once(INCLUDE_DIR.'mobileFunctions.php');
	mfInsertHead(array('topControlsExtra'=>mfButton(false,'javascript:goGeneral()','resourceIcon.png')));
	?>
<div id="tmpResponse" style="display:none"></div>
<?php
	echo mfListTable();
	echo mfListItem(false,outImage('prompt.gif').'&nbsp;',false,'<input style="width:100%" name="cmdInput" onkeydown="kd(event)">',false,outImage(outIcon('go')),'onclick="submitCommand()"');
?>
</table>
<form style="display:none" name="cmdForm" id="cmdForm" method="POST" enctype="multipart/form-data"><input type="hidden" name="cmd"></form>
<br>
<div class="frame1">
<div style="overflow:auto;position:relative;height:80%" id="scrollDiv">
<div id="promptOutput"><br>
<?php echo cfRGetVar('promptOutput');?><br><br><br></div>
<div id="promptDirectory"><?php echo str_replace('/','\\',cfRGetVar('promptDirectory'));?>></div>
</div>
</div>
<script type="text/javascript">
var cmds=new Array();
var cmdsPos=0;
var maxLine=<?php echo (int)cfRGetVar('promptMaxLinesMobile');?>;
var locked=0;
function kd(e){
	if(!e) e=W.event; if(!e) return;
	kc=e.which?e.which:e.keyCode;
	if(kc==13) submitCommand();
}
function goGeneral(){D.location="<?php echo $_SERVER['PHP_SELF'];?>?panel=general";}
function setDirectory(nd){dgi('promptDirectory').innerHTML=nd.replace(/\//g,'\\')+">";}
function submitCommand(){
	if(locked) return;
	locked=1;
	var cmd=dgn('cmdInput').value;
	if(cmd) cmds[cmds.length]=cmd;
	cmdsPos=cmds.length;
	if(cmd)
		dgi('promptOutput').innerHTML+='<br>'+dgi('promptDirectory').innerHTML+cmd+'<br>';
	else
		dgi('promptOutput').innerHTML+='<br>'+dgi('promptDirectory').innerHTML;

	dgn('cmdInput').value='';
	sendData('cmd='+cmd);
}
function processResponse(){
	var buff=dgi('promptOutput').innerHTML+dgi("tmpResponse").innerHTML;
	if(maxLine>0){
		var nbBr=maxLine;
		var pos=buff.length;
		while(nbBr-- >0 && pos>0) pos=buff.lastIndexOf('<br>',pos-1)
		if(pos>0) buff=buff.substr(pos);
	}
	dgi('promptOutput').innerHTML=buff;
	var txt='',nb=0;
	var h=(screen.availHeight)?screen.availHeight:screen.height;
	while(dgi("promptDirectory").offsetTop+dgi("promptOutput").offsetTop>h-10 && nb<10){
		nb++;
		if(!txt) txt=dgi('promptOutput').innerHTML;
		txt=txt.substr(txt.indexOf("<br>")+4);
		dgi('promptOutput').innerHTML=txt;
	}

	dgi("tmpResponse").innerHTML='';
	dgi("scrollDiv").scrollTop = dgi("scrollDiv").scrollHeight;

	locked=0;
}
dgn('cmdInput').focus();
</script>
<?php
	exit;
}

/**
 * Convert process output to UTF-8/HTML code
 *
 * @param string $in
 * @return string
 */
function processResponse($in,$processDirectory='auto'){

	$out=$in;
	$out=iconv('437','UTF-8',$out);


	// Encode ouptut
	$out=str_replace('<','&lt;',$out);
	$out=str_replace("\r",'',$out);
	$out=str_replace("\n",'<br>',$out);
	$out=str_replace(chr(12),'*weezoClear*',$out);

	// Remove last line containing path>
	if($processDirectory){
		$lastLine=substr($out,strrpos($out,"<br>"));
		$dir=substr($lastLine,4,strlen($lastLine)-5);

		if($processDirectory===true || ($processDirectory==='auto' && is_dir($dir))){
			$out=substr($out,0,strrpos($out,"<br>"));
			cfRSetVar('promptDirectory',$dir);
		}
	}

	// Finish output encoding
	$out=str_replace(" ",'&nbsp;',$out);
	$out=str_replace("	",'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',$out);

	if($processDirectory){
		// Set response header (to be removed from each response)
		if(!($rh=cfRGetVar('responseHeader'))) {
			cfRSetVar('responseHeader',$out.'<br>');
		}
		else{
			$out=substr($out,strlen($rh));
		}
		// Remove command itself
		$out=substr($out,strpos($out,'<br>')+4);
	}
	//cfDbg(cfDbgTxt($in));


	return $out;
}


/*
 ***************************************************************************************************************************
 * Verify access rights
 ***************************************************************************************************************************
 */
if(cfUGetVar('administrator')!=true || !cfGGetVar('remoteAdministrationAuthorized') || !cfRGetVar('advancedAdministration') || !cfRGetVar('promptAuthorized')) outDisplayErrorPage(cfcaption('errorRemoteAdministrationNotAuthorized'));


//INIT PROMPT DATA
if(!cfRGetVar('promptInitialized')){
	cfRSetVar('promptDirectory',cfAppSharedDir());
	chdir(cfRGetVar('promptDirectory'));
	cfRSetVar('promptOutput',processResponse(cfStreamProc('cmd',array('stdout'=>'return'))));
	cfRInitVar('promptMaxLines',400);
	cfRInitVar('promptMaxLinesMobile',50);
	cfRSetVar('promptInitialized',1);
}


/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
if(cfIsAsync()){
	cfAsyncHeader();
	if(isset($_POST['cmd'])){
		// Return to general admin panel if user types "exit"
		if($_POST['cmd']=='exit') {
			echo cfAsyncXMLJSaction('document.location="index.php?panel=general"');
			die(cfAsyncFooter());
		}
		chdir(cfRGetVar('promptDirectory'));

		$cmd=iconv('UTF-8','437',$_POST['cmd']);

		function stdoutCB($buff){$_ENV['stdout'].=$buff;return '';}
		function stderrCB($buff){$_ENV['stderr'].=$buff;return '';}
		$_ENV['stderr']=$_ENV['stdout']='';

		cfStreamProc('cmd',array('stdout'=>'stdoutCB','stderr'=>'stderrCB'),((strlen($cmd)?array('writeStdin'=>$cmd."\n"):'')));

		$res=processResponse($_ENV['stdout']).processResponse($_ENV['stderr'],false);
		echo cfAsyncXMLInnerHTMLbyId($res,'tmpResponse');
		echo cfAsyncXMLJSaction('processResponse()');
		echo cfAsyncXMLJSaction('setDirectory("'.str_replace('\\','/',cfRGetVar('promptDirectory')).'")');
	}
	die(cfAsyncFooter());
}

/*
 ***************************************************************************************************************************
 * Display page
 ***************************************************************************************************************************
 */

if(cfIsMobile('Wii','iPhone')) promptDisplayMobilePage();

?>
<style type="text/css">
.dos{color:#CCC;background:black; font-family:Tahoma,sans-serif,monospace; font-weight:bold; font-size:10px; font-stretch:wider;border:0}
</style>
<form style="display:none" name="cmdForm" id="cmdForm" method="POST" enctype="multipart/form-data"><input name="cmd"></form>
<?php
echo outDivFrame('frame1');
echo outTableTransparent('dos','height:100px;position:relative','id="dosTable"');
?>
<tr valign="bottom">
	<td class="dos" colspan="2" style="padding:0.2em;padding-right:0" valign="bottom">
		<div style="overflow:auto;position:relative;height:100%" id="scrollDiv">
			<div id="promptOutput">
			<?php echo cfRGetVar('promptOutput');?>
			</div>
		</div>
	</td>
</tr>
<tr style="height:1em">
<td class="dos" style="width:1%;white-space:nowrap" id="promptDirectory"><?php echo str_replace('/','\\',cfRGetVar('promptDirectory'));?>></td>
<td style="width:99%;white-space:nowrap;overflow:hidden" class="dos"">
<?php echo outImage(outIcon('loadingBlack'),false,'id="loadingIcon"','display:none;vertical-align:middle;height:1em;width:1em;margin-left:0.2em');?><input name="cmdInput" class="dos" style="width:100%">
</td>
</tr></table>
</div>
<div id="tmpResponse" style="display:none"></div>
<script type="text/javascript">
var cmds=new Array();
var cmdsPos=0;
var maxLine=<?php echo (int)cfRGetVar('promptMaxLines');?>;
var locked=0;
function setDirectory(nd){dgi('promptDirectory').innerHTML=nd.replace(/\//g,'\\')+">";}
function processResponse(){
	var buff=dgi("tmpResponse").innerHTML;
	if(buff.indexOf('*weezoClear*')!=-1) buff=buff.substr(buff.lastIndexOf('*weezoClear*')+12);
	else buff=dgi('promptOutput').innerHTML+buff;
	if(maxLine>0){
		var nbBr=maxLine;
		var pos=buff.length;
		while(nbBr-- >0 && pos>0) pos=buff.lastIndexOf('<br>',pos-1)
		if(pos>0) buff=buff.substr(pos);
	}
	dgi('promptOutput').innerHTML=buff;
	dgi("tmpResponse").innerHTML='';
	dgi("scrollDiv").scrollTop = dgi("scrollDiv").scrollHeight;
	dgi('loadingIcon').style.display='none';
	dgn('cmdInput').style.display='';
	locked=0;
}
function init(){setTimeout("winResized(winMe.getInnerWidth(),winMe.getInnerHeight())",50);}
function winResized(w,h){
	setActualHeight(dgi("dosTable"),h-actualOffsetTop(dgi("dosTable"))-20);
	setActualHeight(dgi("scrollDiv"),dgi("scrollDiv").offsetHeight);
}
function submitCommand(){
	locked=1;
	var cmd=dgn('cmdInput').value;
	if(cmd) cmds[cmds.length]=cmd;
	cmdsPos=cmds.length;
	if(cmd)
		dgi('promptOutput').innerHTML+='<br>'+dgi('promptDirectory').innerHTML+cmd+'<br>';
	else
		dgi('promptOutput').innerHTML+='<br>'+dgi('promptDirectory').innerHTML;
	dgi("scrollDiv").scrollTop = dgi("scrollDiv").scrollHeight;
	dgn('cmd').value=cmd;
	dgn('cmdInput').value='';
	dgi('loadingIcon').style.display='';
	dgn('cmdInput').style.display='none';
	asyncSubmitForm('cmdForm');
}
function keyPressed(e){
	var ctrl=0;
	if(e && e.which){ // Gecko
		kc=e.which;
		ctrl=e.ctrlKey;
	}
	else if(window.event){ // IE & Opera
		kc=window.event.keyCode;
		ctrl=window.event.ctrlKey;
	}
	if(kc==13 && !locked) {
		submitCommand();
	}
	if(kc==38){//Up
		if(!cmds.length) return;
		cmdsPos=Math.max(0,cmdsPos-1);
		dgn('cmdInput').value=cmds[cmdsPos];
	}
	if(kc==40){//Down
		if(!cmds.length) return;
		cmdsPos=Math.min(cmds.length-1,cmdsPos+1);
		dgn('cmdInput').value=cmds[cmdsPos];
	}
	if(!ctrl) dgn('cmdInput').focus();
}
document.onkeyup=keyPressed;
document.onload=init();
dgn('cmdInput').focus();
</script>