<?php
define('LAYOUT_LIST_WIDTH',120);

require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'bookmarkFunctions.php');

/*
 ***************************************************************************************************************************
 * Initialize resource
 ***************************************************************************************************************************
 */
bfInit();

/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
bfProcessPOST();

/**
 * Mobiles
 */
if(cfIsMobile()) {require(dirname(__FILE__).'/mobileIndex.php');exit;}

/*
 ***************************************************************************************************************************
 * Insert HEAD, JS functions and form
 ***************************************************************************************************************************
 */
bfInsertExplorerHeadAndBody();
echo cfScriptLink('wz_dragdrop.js');


/*
 ***************************************************************************************************************************
 * Generate bookmarks tree (not treeView...) and thumbnails
 ***************************************************************************************************************************
 */
bfGenerateBookmarksTree();
$bookmarks=cfRGetVar('bookmarks');


// insert comments edition "dialog box"
bfInsertCommentsEditionForm();

// Tree node select function (must be placed before tree creation)
?>
<script type="text/javascript">function selectBM(n){return selectBMTreeNode(n)}</script>
<style type="text/css">
fieldset{vertical-align:top}
.tnFrame{background:#F0F0F0;border:1px solid #CCC;position:relative;text-align:center;display:block;margin-bottom:-1em}
</style>
<?php

/*
foreach ($bookmarks as $k=>$v) if($v['type']=='b'){
	echo '<img src="'.(cfExtImage(mfFaviconFile($v['url']))).'">';
	echo $v["name"]." - ".$v['url'];
	echo '<img src="'.(cfExtImage(bfThumbnailFile($v['url']),50,50)).'">';
	echo '<br>';
}
*/

// Outter frame
echo outDivFrame('frame1');
$l=cfUTF8Encode(cfRGetVar('name')).'&nbsp;&nbsp;&nbsp;';
if(!cfRGetVar('sortTreeView')) $l.=outButton(false,'javascript:sortTreeView(1)',outIcon('sdown16'));
else $l.=outButton(false,'javascript:sortTreeView(0)',outIcon('sdownNo16'),false,'sortTreeViewNo');

$r='<span id="controls"></span>';

// Layout selection buttons
if(cfRGetVar('displayThumbnails')) {
	$bookmarksLayout=cfRGetVar('bookmarksLayout');
	$singleBookmarkLayout=cfRGetVar('singleBookmarkLayout');
	cfSetSavedRVar('bookmarksLayout','singleBookmarkLayout');

	// Single bookmark displayed controls
	$r.='<span id="singleControls">';

	// thumbnail preview
	$capt=cfCaption('genPreview');
	$r.=outButton(false,"javascript:singleBookmarkLayoutSet('thumbnail')",outIcon('fi/icoImage2'),$capt,'singleBookmarkLayout_thumbnail',false,false,$singleBookmarkLayout==='thumbnail');

	// Embeded website
	$capt=cfCaption('genSite');
	$r.=outButton(false,"javascript:singleBookmarkLayoutSet('web')",outIcon('fi/icoURL'),$capt,'singleBookmarkLayout_web',false,false,$singleBookmarkLayout==='web');

	$r.='</span>&nbsp;&nbsp;';

	// Multiple bookmarks displayed controls
	$r.='<span id="multipleControls">';

	// List layout
	$capt=cfCaption('genDisplay').' - 1';
	$r.=outButton(false,"javascript:bookmarksLayoutSet('list')",outIcon('displayList'),$capt,'bookmarksLayout_list',false,false,$bookmarksLayout==='list');

	// Icons layout
	$capt=cfCaption('genDisplay').' - 2';
	$r.=outButton(false,"javascript:bookmarksLayoutSet('icons')",outIcon('displayIcons'),$capt,'bookmarksLayout_icons',false,false,$bookmarksLayout==='icons');

	// Full layout
	$capt=cfCaption('genDisplay').' - 3';
	$r.=outButton(false,"javascript:bookmarksLayoutSet('full')",outIcon('displayFull'),$capt,'bookmarksLayout_full',false,false,$bookmarksLayout==='full');
	$r.='</span>';
}
else $r.='<span id="singleControls"></span><span id="multipleControls"></span>';

echo outFrameHeaderTable('frame1Header',$l,$r);
echo outTableTransparent().'<tr>';

// Treeview frame
echo '<td class="frame2 vBanner" style="width:1px;vertical-align:top'.((cfRGetVar('treeViewPanel')?'':';display:none')).'" id="treeViewPanel">';

// Generate tree
$treeView=bfTreeView();
echo $treeView->HTML(false,false,false,'width:240px');

echo '</td>';

// Toggle collapse control
$icons='<div style="'.outCssOpacity(50).';margin-top:0.4em">'.outImage(outIcon('folder')).'</div>';
echo outCollapsableTD('treeViewPanel','left',array('innerHTML'=>$icons,'class'=>'vBanner'));


// Main bookmarks TD
echo '<td class="frame2" style="vertical-align:top"><div id="bookmarksDiv" style="overflow:auto;vertical-align:top"></div></td>';

// We're done
echo '</tr></table>';

?>
<form method="POST" name="sortTreeViewForm" style="display:none"><input name="sortTreeView"></form>
<form name="suppForm" method="post" enctype="multipart/form-data" style="display:none">
<input name="resId" value="<?php echo $_SESSION['activeResourceId'];?>">
<input name="suppress" id="suppress"></form>

<script type="text/javascript">
var bookmarksLayout="<?php echo cfRGetVar('bookmarksLayout')?>";
var singleBookmarkLayout="<?php echo cfRGetVar('singleBookmarkLayout')?>";
var bmArray;
var displayThumbnails=<?php echo (int)cfRGetVar('displayThumbnails')?>;
var thumbnailSizeIcons="<?php echo cfRGetVar('thumbnailSizeIcons')?>";
var thumbnailSizeFull="<?php echo cfRGetVar('thumbnailSizeFull')?>";
var thumbnailRatio="<?php echo cfRGetVar('thumbnailRatio')?>";
var monitorTimeout=0;
var monitorDelay=<?php echo max(1000,(int)cfRGetVar('monitorDelay'));?>;
var displayed;
var editionAllowed=<?php echo (int)bfEditAllowed();?>;

var addToBookmarksButtonTemplateS='<?php echo addslashes(outButtonSmall(false,'javascript:ACTION',outIcon('favorites'),'TITLE',false,' rel="sidebar"'))?>';
var addToBookmarksButtonTemplate='<?php echo addslashes(outButton(false,'javascript:ACTION',outIcon('favorites'),'TITLE',false,' rel="sidebar"'))?>';
var editCommentsButtonTemplateS='<?php echo addslashes(outButtonSmall(false,'javascript:ACTION',outIcon('edit'),cfCaption('genEdit')))?>';
var editCommentsButtonTemplate='<?php echo addslashes(outButton(false,'javascript:ACTION',outIcon('edit'),cfCaption('genEdit')))?>';
var suppButtonTemplateS='<?php echo addslashes(outButtonSmall(false,'javascript:ACTION',outIcon('del'),cfCaption('genDelete')))?>';
var suppButtonTemplate='<?php echo addslashes(outButton(false,'javascript:ACTION',outIcon('del'),cfCaption('genDelete')))?>';
var newBookmarkButtonTemplateS='<?php echo addslashes(outButtonSmall(false,'javascript:ACTION',outIcon('new'),cfCaption('bookmarksNewBookmark')))?>';
var newBookmarkButtonTemplate='<?php echo addslashes(outButton(false,'javascript:ACTION',outIcon('new'),cfCaption('bookmarksNewBookmark')))?>';
var fullScreenButtonTemplate='<?php echo addslashes(outButton(false,'javascript:ACTION',outIcon('fscreen'),cfCaption('genOpen')))?>';

function bmOpen(index){W.open(bmArray[index]['url'])}
function addToBookmarksButton(i,small){
	var bt=small?addToBookmarksButtonTemplateS:addToBookmarksButtonTemplate;
	if(W.sidebar||W.external) return bt.replace(/ACTION/g,"addToBookmarks('"+i+"')").replace(/TITLE/g,bmArray[i]['label']);
	else if(W.opera && W.print) return bt.replace(/javascript:ACTION/g,bmArray[i]['url']).replace(/TITLE/g,bmArray[i]['label']);
	else return '';
}
function editCommentsButton(i,small){
	var bt=small?editCommentsButtonTemplateS:editCommentsButtonTemplate;
	return bt.replace(/ACTION/g,"ce('show',"+i+")");
}
function suppButton(i,small){
	var bt=small?suppButtonTemplateS:suppButtonTemplate;
	return bt.replace(/ACTION/g,"supp("+i+")");
}
function newBookmarkButton(i,small){
	var bt=small?newBookmarkButtonTemplateS:newBookmarkButtonTemplate;
	return bt.replace(/ACTION/g,"newBookmark(\'show\',"+i+")");
}
function fullScreenButton(i){return fullScreenButtonTemplate.replace(/javascript:ACTION/,"javascript:bmOpen("+i+")")}
function addToBookmarks(i){localBookmark(bmArray[i]['url'],bmArray[i]['label'])}
function localBookmark(url,label){
	if (W.sidebar) return W.sidebar.addPanel(label, url, "");
	if (W.external) return W.external.AddFavorite(url,label);
}

function tnResizedUrl(url,w){
	return url.replace(/\/w[\.][0]{0,1}/,"/w."+w).replace(/\/h[\.][0]{0,1}/,"/h."+Math.floor(w*thumbnailRatio))
}

function sortTreeView(s){
	if(s) {wl.button.disable(dgi('sortTreeView'));wl.button.enable(dgi('sortTreeViewNo'));}
	else  {wl.button.disable(dgi('sortTreeViewNo'));wl.button.enable(dgi('sortTreeView'));}
	dgn('sortTreeView',0).value=s; D.forms.sortTreeViewForm.submit();
}
function bookmarksLayoutSet(l){
	bookmarksLayout=l;
	var e=wl.button.enable;
	e(dgi('bookmarksLayout_list'));
	e(dgi('bookmarksLayout_icons'));
	e(dgi('bookmarksLayout_full'));
	wl.button.disable(dgi('bookmarksLayout_'+l));
	sendData('bookmarksLayoutSet='+l);
}

function singleBookmarkLayoutSet(l){
	singleBookmarkLayout=l;
	var e=wl.button.enable;
	e(dgi('singleBookmarkLayout_thumbnail'));
	e(dgi('singleBookmarkLayout_web'));
	wl.button.disable(dgi('singleBookmarkLayout_'+l));
	sendData('singleBookmarkLayoutSet='+l);
}

// SINGLE
function displaySingle(bm){
	bmArray=new Array(bm);
	displayed='single';
	dgi("singleControls").style.display='';dgi("multipleControls").style.display='none';

	dgi("controls").innerHTML='';

	if(editionAllowed) dgi("controls").innerHTML+=newBookmarkButton(0)+editCommentsButton(0)+suppButton(0)+'&nbsp;&nbsp;&nbsp;&nbsp;'
	dgi("controls").innerHTML+=addToBookmarksButton(0);+'&nbsp;&nbsp;'

	if(singleBookmarkLayout=='web' || !displayThumbnails){
		dgi("controls").innerHTML+=fullScreenButton(0)+'&nbsp;&nbsp;';
		dgi('bookmarksDiv').innerHTML='<iframe src="'+bm['url']+'" style="width:98%;height:98%;border:1px solid #CCC" frameborder="0">';
		return;
	}

	o='';
	o+='<center>';
	o+='<div class="frame3" style="cursor:pointer" onclick="bmOpen(0)"><br><b>'+bm['label']+'</b><br>'+bm['url']+'<br>&nbsp;</div><br>';
	o+='<a href="javascript:bmOpen(0)">';
	if(bm['tnE']){
		o+='<img id="tnSingle" src="'+bm['tn']+'" alt="'+bm['label']+'" style="visibility:hidden" onload="fade(this)" width="<?php echo cfRGetVar('thumbnailSize');?>" height="<?php echo cfRGetVar('thumbnailSize')*cfRGetVar('thumbnailRatio');?>">';
	}
	else {
		o+='<img id="tnSingle" tmp="'+bm['tn']+'" alt="'+bm['label']+'" style="visibility:hidden;display:none" width="<?php echo cfRGetVar('thumbnailSize');?>" height="<?php echo cfRGetVar('thumbnailSize')*cfRGetVar('thumbnailRatio');?>">';
		o+='<div id="tnFSingle" class="tnFrame" style="width:<?php echo cfRGetVar('thumbnailSize');?>;height:<?php echo cfRGetVar('thumbnailSize')*cfRGetVar('thumbnailRatio');?>"><img src="<?php echo outIcon('loading');?>" style="position:relative;top:50%;margin-top:-8px"></div>';
	}
	o+='</a><br><br>';
	if(bm['com']) o+='<div class="frame3" ><br>'+bm['com']+'<br>&nbsp;</div>';
	o+='</center>';
	dgi('bookmarksDiv').innerHTML=o;
	if(!bm['tnE']){monitorTimeout=W.setTimeout(monitorTN,monitorDelay); return;}
}
// MULTIPLE
function displayMultiple(bma){
	out='';
	bmArray=bma;
	displayed='multiple';
	dgi("controls").innerHTML=(editionAllowed)?newBookmarkButton(0)+'&nbsp;&nbsp;&nbsp;&nbsp;':'';

	dgi("singleControls").style.display='none';dgi("multipleControls").style.display='';

	// List
	if(bookmarksLayout=='list'){
		out='<table onmousemove="eHover(event)" onmouseout="eHover()" cellspacing=0 cellpadding=0 width="99%"><colgroup><col width="20"><col width="*"><col width="70"></colgroup>';
		for(var i=0;i<bma.length;i++){
			bm=bma[i];
			o='<tr id="'+i+'" class="eTC '+((i%2)?'even':'odd')+'" eH=1 onmouseover="tooltip(this)">';
			o+='<td class="eTCLeft"><img src="'+bm['ico']+'" style="width:16;height:16">&nbsp;&nbsp;</td>';
			o+='<td onclick="bmOpen('+i+')">'+bm['label']+'</td>';
			o+='<td class="eTCRight" style="text-align:right;white-space:nowrap">'
			if(editionAllowed) o+=suppButton(i,1)+editCommentsButton(i,1)+"&nbsp;"
			o+=addToBookmarksButton(i,1)
			o+='</td></tr>';
			out+=o;
		}
		out+='</table>';
	}

	// Icons
	else if(bookmarksLayout=='icons'){
		for(var i=0;i<bma.length;i++){
			bm=bma[i];
			tnL=tnResizedUrl(bm['tn'],thumbnailSizeIcons);
			o='&nbsp;&nbsp; <fieldset><div id="f'+i+'" style="width:'+thumbnailSizeIcons+';text-align:center" onclick="iconCM(this,event)" oncontextmenu="iconCM(this,event);return false">'
			if(bm['tnE']) o+='<img class="tnImg" src="'+tnL+'" style="width:'+thumbnailSizeIcons+'px;height:'+(thumbnailSizeIcons*thumbnailRatio)+'px;border:1px solid #EEE;visibility:hidden" onload="fade(this)">';
			else{
				o+='<img id="tn'+i+'" class="tnImg" tmp="'+tnL+'" style="width:'+thumbnailSizeIcons+';border:1px solid #EEE;visibility:hidden;display:none">';
				o+='<div id="tnF'+i+'" class="tnFrame" style="width:'+thumbnailSizeIcons+';height:'+Math.floor(thumbnailSizeIcons*thumbnailRatio)+'"><img src="<?php echo outIcon('loading');?>" style="position:relative;top:50%;margin-top:-8px"></div>';
			}
			o+='<br><div style="width:120;height:4em;overflow:hidden">'+bm['label']+'</div>';
			o+='</div></fieldset>';
			out+=o;
		}
	}

	// Full
	else {
		out='<table cellspacing=0 cellpadding=0 width="100%"><colgroup><col width="50%"><col width="50%"></colgroup>';
		for(var i=0;i<bma.length;i++){
			bm=bma[i];
			o='';
			if(i%2==0) o+='<tr>';
			o+='<td><div class="frame3" style="<?php if(cfGetBrowser()!='ie') echo 'min-';?>height:'+(thumbnailSizeIcons*thumbnailRatio+20)+'px;vertical-align:top;margin:0.2em">';
			o+='<img id="tn'+i+'" src="'+tnResizedUrl(bm['tn'],thumbnailSizeIcons)+'" style="float:left;margin:10;cursor:pointer;width:'+thumbnailSizeIcons+';height:'+(thumbnailSizeIcons*thumbnailRatio)+';border:1px solid #EEE;visibility:hidden" onload="fade(this)" onclick="bmOpen('+i+')"><br>'
			o+='<div style="float:right">';
			o+=addToBookmarksButton(i,1)
			if(editionAllowed){
				o+='<br><br>'+suppButton(i,1)+'<br><br>'+editCommentsButton(i,1);
			}
			o+='</div>';
			o+='<div onclick="bmOpen('+i+')" style="cursor:pointer"><b>'+bm['label']+'</b><br>';
			o+=bm['com']?bm['com']:'';
			//o+=bm['tn']+'<br>';
			o+='</div></div></div></td>';
			if(i%2==1) o+='</tr>';
			out+=o;
		}
		if(i%2==1) out+='</tr>';
		out+='</table>';
	}
	dgi('bookmarksDiv').innerHTML=out;

	for(var i=0;i<bma.length;i++) if(!bma[i]['tnE']){monitorTimeout=W.setTimeout(monitorTN,monitorDelay); return;}
}

// Update thumbnails
function updateTN(bma){
	if(displayed=='single'){
		if(bma['tnE']) {
			with(dgi("tnSingle")){
				style.display='';
				src=getAttribute("tmp");
				style.visibility='';
			}
			removeNode(dgi("tnFSingle"));
		}
		else monitorTimeout=W.setTimeout(monitorTN,monitorDelay);
		return;
	}
	for(var i=0;i<bma.length;i++) if(bma[i]['tnE'] && !bmArray[i]['tnE']){
		bmArray[i]['tnE']=1;
		if(dgi('tn'+i)) with(dgi('tn'+i)) {
			style.display='';
			src=getAttribute("tmp");
			style.visibility='';
		}
		if(dgi('tnF'+i)) removeNode(dgi('tnF'+i));
	}
	for(var i=0;i<bma.length;i++) if(!bma[i]['tnE']){monitorTimeout=W.setTimeout(monitorTN,monitorDelay); return}
}

function monitorTN(){sendData('monitorTN='+Math.random());monitorTimeout=0}

function selectBMTreeNode(node){
	if(monitorTimeout) W.clearInterval(monitorTimeout); monitorTimeout=0;
	node.setSelected();
	sendData('selectItem='+node.getExtId())
}
function winResized(){
	alignBottom(dgi("bookmarksDiv"),winMe,25);
	alignBottom(dgi("<?php echo $treeView->HTMLDivID();?>"),winMe,18);
}

// Context menu
var cmSelectedId;
function iconCM(n,e){
	var rc=((e && e.which == 3)||(W.event && event.button == 2));
	var i=n.id.substr(1);
	cmSelectedId=i;
	//if(!rc) {go(id);return};

	var cmi=new Array();u=0;
	cmi[u++]=ContextMenuItem("<?php echo outIcon('fi/icoXml');?>","<?php echo cfCaption('genOpen')?>",'bmOpen(\''+i+'\')',1);
	cmi[u++]=ContextMenuItem('sep');

	if(W.sidebar||W.external) cmi[u++]=ContextMenuItem("<?php echo outIcon('favorites');?>","<?php echo cfCaption('bookmarksAddToFavorites')?>",'addToBookmarks(\''+i+'\')');
	else if(W.opera && W.print) cmi[u++]=ContextMenuItem(false,'<a href="'+bmArray[i]['url']+'" rel="sidebar"><img src="<?php echo outIcon('favorites');?>"><?php echo cfCaption('bookmarksAddToFavorites')?></a>',false);

	cmi[u++]=ContextMenuItem('sep');
	cmi[u++]=ContextMenuItem(false,'<input style="width:'+thumbnailSizeFull*2+'px" value="'+bmArray[i]['url']+'">',false);

	if(editionAllowed){
		cmi[u++]=ContextMenuItem('sep');
		cmi[u++]=ContextMenuItem("<?php echo outIcon('edit');?>","<?php echo cfCaption('genEdit')?>",'ce(\'show\',\''+i+'\')');
		cmi[u++]=ContextMenuItem("<?php echo outIcon('del');?>","<?php echo cfCaption('genDelete')?>",'supp(\''+i+'\')');
		cmi[u++]=ContextMenuItem('sep');
	}
	cmi[u++]=ContextMenuItem(false,'<img src="'+tnResizedUrl(bmArray[i]['tn'],thumbnailSizeFull*2)+'" style="width:'+thumbnailSizeFull*2+'px;height:'+thumbnailSizeFull*2*thumbnailRatio+'px;margin:2em;margin-left:0;visibility:hidden" onload="fade(this)">','bmOpen(\''+i+'\')');
	cmi[u++]=ContextMenuItem('sep');
	if(bmArray[i]['com']) {
		cmi[u++]=ContextMenuItem('sep');
		cmi[u++]=ContextMenuItem(false,'<span class="frame3">'+bmArray[i]['com']+'<br></span>',false);
	}

	var cm=new ContextMenu(cmi,{'fade':1,'centerFirst':!rc});
}

// Title & comments form
function ce(action,i) {
	if(!dgi("cePanel")) return;
	var cePS=dgi("cePanel").style;
	if(action=='hide') {
		fade(dgi("cePanel"),1,0)
		wl.setKeycodeListener(D,null);
		wl.mask.hide();
		return;
	}
	if(action=='show') {
		wl.mask.show(0,1)
		wl.mask.moveAbove(dgi("cePanel"))
		wl.setKeycodeListener(D,ceKD)
		// set dialog box position
		if(navigator.appName=='Netscape') cePS.top=window.pageYOffset+1*screen.availHeight/5+'px';
		else cePS.top=D.body.scrollTop+1*D.body.offsetHeight/5+'px'; //IE & OPERA
		cePS.width=Math.floor((Math.min(600,2*winMe.getInnerWidth()/3)))+'px';
		cePS.left=Math.floor((winMe.getInnerWidth()/2-Math.min(600,2*winMe.getInnerWidth()/3)/2))+'px';

		// fill title and comments
		dgi("editCommentId").innerHTML="";
		dgi("editTitleId").value=bmArray[i]['label'];
		if(bmArray[i]['com']) {
			var str=bmArray[i]['com'].replace(/<BR[ /]{0,2}>/gi,String.fromCharCode(13));
			dgi("editCommentId").value = str;
		}
		else dgi("editCommentId").value="";
		dgi("header").innerHTML = bmArray[i]['label'];

		dgi("item").value=bmArray[i]['id'];
		fade(dgi("cePanel"))

		try{dgi("editCommentId").focus()} catch(e){}
	}
	if(action=='submit') {
		cePS.display='none';
		winMe.setReloading();
		D.ceForm.submit();
	}
}
function ceKD(kc){if(kc==27) ce('hide')}

// Create new bookmark
function newBookmark(action,i) {
	if(!dgi("nbPanel")) return;
	var nbPS=dgi("nbPanel").style;
	if(action=='hide') {
		fade(dgi("nbPanel"),1,0)
		wl.setKeycodeListener(D,null);
		wl.mask.hide();
		return;
	}
	if(action=='show') {
		nbPS.visibility="hidden"
		nbPS.display=""
		wl.mask.show(0,1)
		wl.mask.moveAbove(dgi("nbPanel"))
		wl.setKeycodeListener(D,nbKD)

		// set dialog box position
		if(navigator.appName=='Netscape') nbPS.top=window.pageYOffset+1*screen.availHeight/3+'px';
		else nbPS.top=D.body.scrollTop+1*D.body.offsetHeight/3+'px'; //IE & OPERA
		nbPS.width=Math.floor((Math.min(600,2*winMe.getInnerWidth()/3)))+'px';

		// fill title and comments
		dgi("nbItemId").value=bmArray[i]['id'];
		fade(dgi("nbPanel"))
	}
}
function nbKD(kc){if(kc==27) newBookmark('hide')}

function supp(i) {
	if(!confirm("<?php echo cfCaptionJS('bookmarksConfirmDelete');?>")) return;
	dgi("suppress").value=bmArray[i]['id'];
	winMe.setReloading();
	D.suppForm.submit();
}
function tooltipGetContent(i){
	bm=bmArray[i];
	o='<div style="width:'+(2.5*thumbnailSizeFull)+'"><b>'+bm['label']+'</b><br><br>'+bm['url']+'<br><br>';
	if(bm['tnE']) o+='<center><img src="'+tnResizedUrl(bm['tn'],2*thumbnailSizeFull)+'" style="visibility:hiddene;width:'+(2*thumbnailSizeFull)+';height:'+(thumbnailSizeFull*thumbnailRatio*2)+'" onload="fade(this)"></center><br>';
	if(bm['com']) o+='<div class="frame3">'+bm['com']+'</div>';
	o+='</div>';
	return o
}
winResized();
<?php
bfUpdateDisplay();
echo "\n";
echo cfDragRegisterItems('',false);
?>
</script>
<?php
exit;