<?php

require_once(INCLUDE_DIR.'mobileFunctions.php');

$bandwidths=array('low'=>96,'medium'=>256,'high'=>512);

//if(cfBGetVar('name')=='Android') mfDisplayResourceNotCompatiblePage();

define('M3U8NL',"\n");


/**
 * @desc Display channels buttons
 *
 * @param Playlist object $playlist
 */
function mobileWebTVDisplayChannelsList($playlist){
	echo mfListTable();
	// Display playlist items
	$type=cfRGetVar('displayledChannelsType');
	foreach ($playlist->tracks() as $key => $channel) {
		echo mfListItem("id=\"channel".$key."\" onclick=selectChannel('".$key."') name=\"".$channel['type'].'"'.(($type==$channel['type'])?'':' style="display:none"'),'<img src="'.wtvChannelIcon($channel['name']).'" style="width:52px;height:39px;vertical-align:middle;margin-right:0.5em">',false,cfUTF8Encode($channel['name']),false,'go');
	}
	echo '</table></div>';
}

/**
 * @desc Send iPhone M3U8 playlist
 *
 */
function mobileWebTVIPodM3U(){
	global $playlist;

	// Cut video into 10 fake segments of 999 seconds
	$nb=10;	$int=999;

	$channelId=$_GET['extPlaylistItem'];

	if(!($track=$playlist->track($channelId))) die('Incorrect channel id: '.$channelId);

	// Get stream URL
	$url=$track['url'];

	// Retrieve and parse ASX file
	if(strpos($url,'asx')) $url=wtvGetASXUrl($url);

	// Save url and bandwidth to session var as M3U8 file doesn't carry any info
	cfRSetVar('videoIPhoneCompleteFilename',$url);
	cfRSetVar('videoIPhoneBandwidth',$_GET['bandwidth']);

	// m3u8 content-type header
	WHeaders::contentType('foo.m3u8');

	// Send M3U8 segments file
	cfRangeAccessibleOutputStart();
	echo "#EXTM3U".M3U8NL;
	echo "#EXT-X-MEDIA-SEQUENCE:0".M3U8NL;
	echo "#EXT-X-TARGETDURATION:$int".M3U8NL;

	$resId=$_SESSION['activeResourceId'];

	// Generate segment links
	for($i=1;$i<$nb;$i++){
		echo "#EXTINF:$int,".M3U8NL;
		echo '/ext/'.$resId.'.'.($i*$int).".ts".M3U8NL;
	}
	echo '#EXT-X-ENDLIST';
	cfRangeAccessibleOutputSend();
	exit;
}

/**
 * @desc Redirect to flash player
 *
 */
function mobileWebTVFlash(){
	global $playlist;

	// Set SWF source to *singleVideo*.xml (so /ext/video.php outputs an XML file setting a link to actual FLV file)
	//$chunkLength=(int)cfHGetVar('flashChunkLength');
	$chunkLength=0;
	$src=cfExtVideo('*singleVideo*.xml',array('chunkLength'=>$chunkLength));

	// Ensure requested channel id exists
	$channelId=$_GET['extPlaylistItem'];

	if(!$playlist->track($channelId)) outDisplayErrorPage('Error: cannot find stream');;
	$track=$playlist->track($channelId);

	// Save viewed channel
	cfRSetVar('currentChannel',$channelId);

	// Get stream URL
	$url=$track['url'];

	// Retrieve and parse ASX file
	if(strpos($url,'asx')) $url=wtvGetASXUrl($url);

	// Store singleVideo source and dimensions
	$codec=((cfFfmpegVersion()=='GPL') && cfBGetVar('flash')!=='flashFlv')?'h264':'vp6'; // Video codec: vp6 or h264
	$codec='h264';
	$params=array(
		'q'=>cfRGetVar('videoIPhoneBandwidth'),
		'w'=>800,
		'h'=>480,
		'offset'=>0,
		'chunkLength'=>$chunkLength,
		'format'=>(($codec=='vp6')?'flashFlv':'flashF4v')
		); // Retrieve bandwidth from rvar instead of GET so there is no need for filtering value

	cfRSetVar('singleVideo', cfExtVideo($channelId,$params,'relative'));
	//cfRSetVar('extAccessFunction',false);

	// Set flash player url
	$debug=false; // Flash player debug
	$movieURL='/js/vplayer.swf?'.
		//'&amp;w='.$videoWidth.'&amp;h='.$videoHeight.
		'offset=0'.
		'&autoplay=1'.
		'&buffer='.((cfHGetVar('videoBufferTime'))?cfRGetVar('videoBufferTime'):3).
		'&browser='.cfGetBrowser().
		'&chunkLength='.(int)$chunkLength.
		'&ffmpegVersion='.cfFfmpegVersion().
		'&noCallback=1'.
		'&isMobile='.cfIsMobile().
		'&codec='.$codec.
		'&isTV=1'.
		//'&debug=1'.
		'&file='.$src;

	header('Location: '.$movieURL);
}

/**
 * @desc Redirect to flash player
 *
 */
function mobileWebTVHtml5(){
	global $playlist;

	// Ensure requested channel id exists
	$channelId=$_GET['extPlaylistItem'];

	if(!$playlist->track($channelId)) outDisplayErrorPage('Error: cannot find stream');;
	$track=$playlist->track($channelId);

	// Save viewed channel
	cfRSetVar('currentChannel',$channelId);

	// Get stream URL
	$url=$track['url'];

	// Retrieve and parse ASX file
	if(strpos($url,'asx')) $url=wtvGetASXUrl($url);

	// Store singleVideo source and dimensions

	require_once(INCLUDE_DIR.'viewVideoFunctions.php');

	// Override video name extracted from file name (url) by actual channel name
	cfRSetVar('vvfForcedVideoName',@$track['name']);

	// HTML5 video player
	vfvViewVideo($url,@$_POST['data4'],@$_POST['data5'],array('videoPlayer'=>'html5Auto'));
	exit;
}

/**
 * Function called by /ext/video.php for validating url
 *
 * @param int $completeFilename: channel id
 */
function mobileChannelValidateURL($completeFilename){
	global $playlist;
	$playlist=unserialize(cfRGetVar('playlist'));

	// Flash player: $completeFilename is track number => return url
	if(is_numeric($completeFilename)) {
		$channel=$playlist->track(cfRGetVar('currentChannel'));
		return @$channel['url'];
	}

	// HTML5: $completeFilename is url
	$channel=$playlist->track(cfRGetVar('currentChannel'));

	//if($completeFilename===@$channel['url'])  cfDbg('ok:'.$completeFilename.' '.$channel['url']);
	if($completeFilename===@$channel['url']) return $completeFilename;
}

/**
 * Function called by /ext/video.php for validating url
 *
 * @param int $completeFilename: channel id
 */
function mobileGetChannelFromId($completeFilename){
	global $playlist;

	$playlist=unserialize(cfRGetVar('playlist'));
	$channel=$playlist->track(cfRGetVar('currentChannel'));

	if($completeFilename===@$channel['url']) return $completeFilename;
}


// Included by /ext/video.php
if(defined('SESSION_NAME_PREFIX')) return;

cfRSetVar('extAccessFunction','require_once(cfAppDocRoot()."/res/tv/WebTV/index.php"); return mobileChannelValidateURL($completeFilename);');



// iPhone M3U8 file requested
if(@$_GET['step']=='M3U8' && isset($_GET['bandwidth']) && isset($_GET['extPlaylistItem'])) mobileWebTVIPodM3U();
// Flash player requested
if(@$_GET['step']=='flash' && isset($_GET['extPlaylistItem'])) mobileWebTVFlash();
// HTML5 player requested
if(@$_GET['step']=='html5' && isset($_GET['extPlaylistItem'])) mobileWebTVHtml5();
// Error: flash not supported
if(@$_GET['step']==='error') mfDisplayErrorPage(cfCaption('genError'),outImage(outIcon('flash32')),true);
// Update bandwidth value
if(isset($_POST['bandwidth'])) $_POST['videoIPhoneBandwidth']=$_POST['bandwidth'];
cfAsyncXMLChangePhpVarValue('videoIPhoneBandwidth',array_keys($bandwidths));


//cfRSetVar('extAccessFunction','mobileChannelIdToURL');


/*
 ***************************************************************************************************************************
 * Display playlist page
 ***************************************************************************************************************************
 */

$topControls='';
/**
 * TV / Radio selector
 */
if($playlist->length('tv')>0 && $playlist->length('radio')>0){
	$topControls.=mfButton(false,"javascript:setType('tv')",'tv.png',false,(cfRGetVar('displayledChannelsType')=='tv')?'on':false);
	$topControls.=mfButton(false,"javascript:setType('radio')",'radio.png',false,(cfRGetVar('displayledChannelsType')=='radio')?'on':false);
	$topControls.='&nbsp;&nbsp;';
}

/**
 * Quality controls
 */
foreach ($bandwidths as $k=>$v) $topControls.=mfButton(false,"javascript:selectBandwidth('".$k."')",outIcon('quality'.ucfirst($k)),'id="bandwidthBt'.$k.'"',($k==cfRGetVar('videoIPhoneBandwidth'))?'on':false);


mfInsertHead(array('topControlsLabel'=>cfRGetVar('name'),'topControlsExtra'=>$topControls));


echo outDivFrame('frame1');

mobileWebTVDisplayChannelsList($playlist);

// Quality and channel selection javascript
?>
<script type="text/javascript">
var videoTemplateURL="<?php
// iPhone video
if(cfBGetVar('OS')=='iOS') echo cfHostName().dirname($_SERVER['PHP_SELF']).'/index.php?step=M3U8&extPlaylistItem=PLI&bandwidth=BANDWIDTH';

// Flash video: direct to index.php with id & bandwidth, where wtvProcessPost will store requested parameters and redirect to flash player
else if(cfBGetVar('flash')) echo cfHostName().dirname($_SERVER['PHP_SELF']).'/index.php?step=flash&extPlaylistItem=PLI&bandwidth=BANDWIDTH';
else echo cfHostName().dirname($_SERVER['PHP_SELF']).'/index.php?step=html5&extPlaylistItem=PLI&bandwidth=BANDWIDTH';

// No video support: display a link to flash error page
//else echo cfHostName().dirname($_SERVER['PHP_SELF']).'?step=error';
?>";

var bandwidth="<?php echo cfRGetVar('videoIPhoneBandwidth');?>", bandwidths=[<?php $nb=0; foreach ($bandwidths as $k=>$v) echo (($nb++)?',':'').'"'.$k.'"';?>];
function selectBandwidth(b){
	for(var i=0;i<bandwidths.length;i++) {
		bi=bandwidths[i];
		if(bi==b) wl.liSel('bandwidthBt'+b); else wl.liUnsel('bandwidthBt'+bi);
	}
	bandwidth=b;
	sendData('bandwidth='+b)
}
function selectChannel(k){
	wl.liSel('channel'+k);
	D.location=videoTemplateURL.replace(/PLI/,k).replace(/BANDWIDTH/,bandwidth);
}
function setType(type){
	sendData('setType='+type);
	var i,r=D.getElementsByName('radio');
	for(i=0;i<r.length;i++) r[i].style.display=(type=='radio')?'':'none';
	r=D.getElementsByName('tv');
	for(i=0;i<r.length;i++) r[i].style.display=(type=='tv')?'':'none';
}
</script>
<?php
exit;