<?php
/**
 * WEBCAM
 *
 * Display a page with webcam image
 * Page refreshes itself to update image
 * webcam image is obtained through cfServerSendCommand function
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */
require_once(INCLUDE_DIR.'outputFunctions.php');
require(INCLUDE_DIR.'mobileFunctions.php');

/*
 ***************************************************************************************************************************
 * Insert HEAD, FORMS and JAVASCRIPT functions
 ***************************************************************************************************************************
 */
mfInsertHead(array('topControlsLabel'=>cfCaption('resWebcamStd'),'topControlsExtra'=>'<span id="webcamCaption"></span>'));

?>
<center id="c" style="position:relative">
<div id="imgc" style="position:absolute" onclick="wl.TCToggle();setImageSize(0,0)"></div>
<div id="webcamError" class="warning" style="font-size:130%;position:absolute;top:45%;width:100%;text-align:center;display:none"><?php echo outImageIcon('alert32').cfCaption('webcamError');?></div>
</center>
<script type="text/javascript">
var ctrlH=<?php if(cfBGetVar('name')=='IEMobile') echo IEMOBILE_TOP_CONTROLS_HEIGHT; else echo '0';?>;
var lU=new Date().getTime(),r=<?php echo (1000*cfRGetVar('refreshRate'));?>;
var tO,imgW,imgH,sW,monTO,winBarOW;
function sAW(){return (W.innerWidth)?W.innerWidth:screen.availWidth}
function sAH(){return (W.innerHeight)?W.innerHeight:screen.availHeight}
function init(){
	sW=sAW();
	updateImage();
	mO();
}
function noWebcamDetected(){
	dgi('webcamError').style.display="";
	tO=setTimeout('D.location.reload()',1500)
}
// Request an image update
function updateImage(){
	sendData('viewportWidth='+sAW()+'&viewportHeight='+sAH());
	monTO=setTimeout('updateImage()',3000)
}
function setTimeCaption(c){dgi("webcamCaption").innerHTML=c}

function iL(){
	n=dgi('tmp');
	if(!n.src) return;
	if(dgi('tmp2')) iH(dgi('tmp2'));
	iS(n);
	if(dgi('tmp2')) dgi('imgc').removeChild(dgi('tmp2'));
	n.id='tmp2';
	now=new Date().getTime();

	tO=setTimeout('updateImage()',Math.max(10,r-now+lU));
	lU=now;
}

// Viewport size monitoring
function mO(){
	nW=sAW();
	if(nW!=sW){
		sW=nW;
		clearTimeout(tO);
		setImageSize(0,0);
	}
	setTimeout('mO()',500);
}
// Initialize a hidden buffer image
function iH(n){with(n.style){height='1px'; visibility='hidden'; position='absolute'}}
// Show a buffer image
function iS(n){with(n.style){height='100%';width='100%';visibility='visible';position=''}}
var aaa=0;
// Resize and position image
function setImageSize(w,h){

	var aW=sAW(),aH=sAH()-$('winBar').offsetHeight,s=$('imgc').style,l,iw,ih;

	if((!w) && !h){
		w=imgW;h=imgH
	}
	else imgW=w;imgH=h;

	winBarOW=($('winBar').offsetWidth)?$('winBar').offsetWidth:winBarOW;

	aH*=winBarOW/aW;
	aW*=winBarOW/aW;

	l=(imgW/imgH>aW/aH);

	iw=Math.floor((l)?aW:aH*w/h);
	ih=Math.floor((l)?aW*h/w:aH);

	s.width=iw+'px';
	s.height=ih+'px';

	s.top=Math.floor((aH-ih)/2)+'px';
	s.left=Math.floor((aW-iw)/2)+'px';

	//if(debug||aaa==0) alert(l+'>'+w+'x'+h+' / '+aW+'x'+aH+' => '+iw+'x'+ih+' '+dgi('winBar').offsetHeight+' ('+s.top+') '+$('winBar').offsetWidth+' '+s.width+'...'+sAH())

	aaa++
}
// Set image source, and prepare so image is
function setImage(s){
	clearTimeout(monTO);
	dgi('webcamError').style.display="none";
	var i=D.createElement('img');
	i.id="tmp";	i.onload=iL;

	iH(i); dgi('imgc').appendChild(i);
	i.src=s;
}
init();
</script>
</body></html>